#ifdef INCL_DOS
#define INCL_DOSPROCESS
#define INCL_DOSFILEMGR
#define INCL_DOSMEMMGR
#define INCL_DOSSEMAPHORES
#define INCL_DOSDATETIME
#define INCL_DOSMODULEMGR
#define INCL_DOSRESOURCES
#define INCL_DOSNLS
#define INCL_DOSEXCEPTIONS
#define INCL_DOSMISC
#define INCL_DOSMONITORS
#define INCL_DOSQUEUES
#define INCL_DOSSESMGR
#define INCL_DOSDEVICES
#define INCL_DOSNMPIPES
#define INCL_DOSPROFILE
#define INCL_DOSMVDM
#endif

#ifdef INCL_ERRORS
#define INCL_DOSERRORS
#endif

#define CCHMAXPATH					260
#define CCHMAXPATHCOMP					256


#if (defined(INCL_DOSPROCESS)||!defined(INCL_NOCOMMON))

#define EXIT_THREAD					0
#define EXIT_PROCESS					1

ULONG DosBeep(ULONG, ULONG) asm ("DosBeep");
ULONG DosExit(ULONG, ULONG) asm ("DosExit");
#endif

#ifdef INCL_DOSPROCESS

#include <bsetib.h>

#define DCWA_PROCESS					0
#define DCWA_PROCESSTREE				1
#define DCWW_WAIT					0
#define DCWW_NOWAIT					1

#define DKP_PROCESSTREE					0
#define DKP_PROCESS					1

#define EXEC_SYNC					0
#define EXEC_ASYNC					1
#define EXEC_ASYNCRESULT				2
#define EXEC_TRACE					3
#define EXEC_BACKGROUND					4
#define EXEC_LOAD					5
#define EXEC_ASYNCRESULTDB				6

#define EXLST_ADD					1
#define EXLST_REMOVE					2
#define EXLST_EXIT					3

#define PRTYC_NOCHANGE					0
#define PRTYC_IDLETIME					1
#define PRTYC_REGULAR					2
#define PRTYC_TIMECRITICAL				3
#define PRTYC_FOREGROUNDSERVER				4

#define PRTYD_MINIMUM					-31
#define PRTYD_MAXIMUM					31

#define PRTYS_PROCESS					0
#define PRTYS_PROCESSTREE				1
#define PRTYS_THREAD					2

#define TC_EXIT						0
#define TC_HARDERROR					1
#define TC_TRAP						2
#define TC_KILLPROCESS					3
#define TC_EXCEPTION					4

typedef VOID FNTHREAD(ULONG);
typedef FNTHREAD *PFNTHREAD;

typedef VOID FNEXITLIST(ULONG);
typedef FNEXITLIST * PFNEXITLIST;

typedef struct _RESULTCODES {
	ULONG codeTerminate;
	ULONG codeResult;
} RESULTCODES, *PRESULTCODES;

ULONG DosCreateThread(PTID, PFNTHREAD, ULONG, ULONG, ULONG) asm ("DosCreateThread");
ULONG DosResumeThread(TID) asm ("DosResumeThread");
ULONG DosSuspendThread(TID) asm ("DosSuspendThread");
ULONG DosGetInfoBlocks(PTIB *,PPIB *) asm ("DosGetInfoBlocks");
ULONG DosWaitChild(ULONG, ULONG, PRESULTCODES, PPID, PID) asm ("DosWaitChild");
ULONG DosWaitThread(PTID, ULONG) asm ("DosWaitThread");
ULONG DosSleep(ULONG) asm ("DosSleep");
ULONG DosDebug(PVOID) asm ("DosDebug");
ULONG DosEnterCritSec(VOID) asm ("DosEnterCritSec");
ULONG DosExitCritSec(VOID) asm ("DosExitCritSec");
ULONG DosExitList(ULONG, PFNEXITLIST) asm ("DosExitList");
ULONG DosExecPgm(PCHAR, LONG, ULONG, PSZ, PSZ, PRESULTCODES, PSZ) asm ("DosExecPgm");
ULONG DosSetPriority(ULONG, ULONG, LONG, ULONG) asm ("DosSetPriority");
ULONG DosKillProcess(ULONG, PID) asm ("DosKillProcess");

#endif

#if (defined(INCL_DOSFILEMGR)||!defined(INCL_NOCOMMON))

#define DCPY_EXISTING					0x0001
#define DCPY_APPEND					0x0002
#define DCPY_FAILEAS					0x0004

#define DSPI_WRTTHRU					0x10

#define EAT_BINARY					0xFFFE
#define EAT_ASCII					0xFFFD
#define EAT_BITMAP					0xFFFB
#define EAT_METAFILE					0xFFFA
#define EAT_ICON					0xFFF9
#define EAT_EA						0xFFEE
#define EAT_MVMT					0xFFDF
#define EAT_MVST					0xFFDE
#define EAT_ASN1					0xFFDD

#define ENUMEA_LEVEL_NO_VALUE				1L
#define ENUMEA_REFTYPE_FHANDLE				0
#define ENUMEA_REFTYPE_PATH				1
#define ENUMEA_REFTYPE_MAX				ENUMEA_REFTYPE_PATH

#define FEA_NEEDEA					0x80

#define FHB_DSKREMOTE					0x8000
#define FHB_CHRDEVREMOTE				0x8000
#define FHB_PIPEREMOTE					0x8000

#define FHT_DISKFILE					0x0000
#define FHT_CHRDEV					0x0001
#define FHT_PIPE					0x0002

#define FIL_STANDARD					1
#define FIL_QUERYEASIZE					2
#define FIL_QUERYEASFROMLIST				3
#define FIL_QUERYFULLNAME				5

#define FILE_BEGIN					0x0000
#define FILE_CURRENT					0x0001
#define FILE_END					0x0002
#define FILE_NORMAL					0x0000
#define FILE_READONLY					0x0001
#define FILE_HIDDEN					0x0002
#define FILE_SYSTEM					0x0004
#define FILE_DIRECTORY					0x0010
#define FILE_ARCHIVED					0x0020
#define FILE_IGNORE					0x10000
#define FILE_EXISTED					0x0001
#define FILE_CREATED					0x0002
#define FILE_TRUNCATED					0x0003
#define FILE_OPEN					0x0001
#define FILE_TRUNCATE					0x0002
#define FILE_CREATE					0x0010

#define FS_ATTACH					0
#define FS_DETACH					1
#define FS_SPOOLATTACH					2
#define FS_SPOOLDETACH					3

#define FSAIL_QUERYNAME					1
#define FSAIL_DEVNUMBER					2
#define FSAIL_DRVNUMBER					3

#define FSAT_CHARDEV					1
#define FSAT_PSEUDODEV					2
#define FSAT_LOCALDRV					3
#define FSAT_REMOTEDRV					4

#define FSCTL_HANDLE					1
#define FSCTL_PATHNAME					2
#define FSCTL_FSDNAME					3
#define FSCTL_ERROR_INFO				1
#define FSCTL_MAX_EASIZE				2

#define FSIL_ALLOC					1
#define FSIL_VOLSER					2

#define HANDTYPE_FILE					0x0000
#define HANDTYPE_DEVICE					0x0001
#define HANDTYPE_PIPE					0x0002
#define HANDTYPE_NETWORK				0x8000

#define HDIR_SYSTEM					1
#define HDIR_CREATE					(-1)

#define MUST_HAVE_READONLY				((FILE_READONLY<<8)|FILE_READONLY)
#define MUST_HAVE_HIDDEN				((FILE_HIDDEN<<8)|FILE_HIDDEN)
#define MUST_HAVE_SYSTEM				((FILE_SYSTEM<<8)|FILE_SYSTEM)
#define MUST_HAVE_DIRECTORY				((FILE_DIRECTORY<<8)|FILE_DIRECTORY)
#define MUST_HAVE_ARCHIVED				((FILE_ARCHIVED<<8)|FILE_ARCHIVED)

#define OPEN_ACTION_FAIL_IF_EXISTS			0x0000
#define OPEN_ACTION_OPEN_IF_EXISTS			0x0001
#define OPEN_ACTION_REPLACE_IF_EXISTS			0x0002
#define OPEN_ACTION_FAIL_IF_NEW				0x0000
#define OPEN_ACTION_CREATE_IF_NEW			0x0010
#define OPEN_ACCESS_READONLY				0x0000
#define OPEN_ACCESS_WRITEONLY				0x0001
#define OPEN_ACCESS_READWRITE				0x0002
#define OPEN_SHARE_DENYREADWRITE			0x0010
#define OPEN_SHARE_DENYWRITE				0x0020
#define OPEN_SHARE_DENYREAD				0x0030
#define OPEN_SHARE_DENYNONE				0x0040
#define OPEN_FLAGS_NOINHERIT				0x0080
#define OPEN_FLAGS_NO_LOCALITY				0x0000
#define OPEN_FLAGS_SEQUENTIAL				0x0100
#define OPEN_FLAGS_RANDOM				0x0200
#define OPEN_FLAGS_RANDOMSEQUENTIAL			0x0300
#define OPEN_FLAGS_NO_CACHE				0x1000
#define OPEN_FLAGS_FAIL_ON_ERROR			0x2000
#define OPEN_FLAGS_WRITE_THROUGH			0x4000
#define OPEN_FLAGS_DASD					0x8000
#define OPEN_FLAGS_NONSPOOLED				0x00040000

#define SEARCH_PATH					0x0000
#define SEARCH_CUR_DIRECTORY				0x0001
#define SEARCH_ENVIRONMENT				0x0002
#define SEARCH_IGNORENETERRS				0x0004

#pragma pack(1)

typedef struct _DENA1 {
	UCHAR reserved;
	UCHAR cbName;
	USHORT cbValue;
	UCHAR szName[1];
} DENA1, *PDENA1;

#pragma pack(4)

typedef struct _EASIZEBUF {
	USHORT cbMaxEASize;
	ULONG cbMaxEAListSize;
} EASIZEBUF, *PEASIZEBUF;

typedef struct _FDATE {
	UINT day :5;
	UINT month :4;
	UINT year :7;
} FDATE, *PFDATE;

typedef struct _FEA {
	BYTE fEA;
	BYTE cbName;
	USHORT cbValue;
} FEA, *PFEA;

#pragma pack(1)

typedef struct _FEA2 {
	ULONG oNextEntryOffset;
	BYTE fEA;
	BYTE cbName;
	USHORT cbValue;
	CHAR szName[1];
} FEA2, *PFEA2;

typedef FEA2 DENA2;
typedef PFEA2 PDENA2;

typedef struct _FEA2LIST {
	ULONG cbList;
	FEA2 list[1];
} FEA2LIST, *PFEA2LIST;

#pragma pack(4)

typedef struct _FEALIST {
	ULONG cbList;
	FEA list[1];
} FEALIST, *PFEALIST;

typedef struct _FILELOCK {
	LONG lOffset;
	LONG lRange;
} FILELOCK, *PFILELOCK;

typedef struct _FSALLOCATE {
	ULONG idFileSystem;
	ULONG cSectorUnit;
	ULONG cUnit;
	ULONG cUnitAvail;
	USHORT cbSector;
} FSALLOCATE, *PFSALLOCATE;

typedef struct _FSQBUFFER {
	USHORT iType;
	USHORT cbName;
	UCHAR szName[1];
	USHORT cbFSDName;
	UCHAR szFSDName[1];
	USHORT cbFSAData;
	UCHAR rgFSAData[1];
} FSQBUFFER, *PFSQBUFFER;

typedef struct _FSQBUFFER2 {
	USHORT iType;
	USHORT cbName;
	USHORT cbFSDName;
	USHORT cbFSAData;
	UCHAR szName[1];
	UCHAR szFSDName[1];
	UCHAR rgFSAData[1];
} FSQBUFFER2, *PFSQBUFFER2;

typedef struct _FTIME {
	UINT twosecs :5;
	UINT minutes :6;
	UINT hours :5;
} FTIME, *PFTIME;

typedef struct _FILEFINDBUF {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	USHORT attrFile;
	UCHAR cchName;
	CHAR achName[CCHMAXPATHCOMP];
} FILEFINDBUF, *PFILEFINDBUF;

#pragma pack(2)

typedef struct _FILEFINDBUF2 {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	USHORT attrFile;
	ULONG cbList;
	UCHAR cchName;
	CHAR achName[CCHMAXPATHCOMP];
} FILEFINDBUF2, *PFILEFINDBUF2;

#pragma pack(4)

typedef struct _FILEFINDBUF3 {
	ULONG oNextEntryOffset;
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	ULONG attrFile;
	UCHAR cchName;
	CHAR achName[CCHMAXPATHCOMP];
} FILEFINDBUF3, *PFILEFINDBUF3;

typedef struct _FILEFINDBUF4 {
	ULONG oNextEntryOffset;
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	ULONG attrFile;
	ULONG cbList;
	UCHAR cchName;
	CHAR achName[CCHMAXPATHCOMP];
} FILEFINDBUF4, *PFILEFINDBUF4;

typedef struct _FILESTATUS {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	USHORT attrFile;
} FILESTATUS, *PFILESTATUS;

typedef struct _FILESTATUS2 {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	USHORT attrFile;
	ULONG cbList;
} FILESTATUS2, *PFILESTATUS2;

typedef struct _FILESTATUS3 {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	ULONG attrFile;
} FILESTATUS3, *PFILESTATUS3;

typedef struct _FILESTATUS4 {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	FDATE fdateLastAccess;
	FTIME ftimeLastAccess;
	FDATE fdateLastWrite;
	FTIME ftimeLastWrite;
	ULONG cbFile;
	ULONG cbFileAlloc;
	ULONG attrFile;
	ULONG cbList;
} FILESTATUS4, *PFILESTATUS4;

typedef struct _GEA {
	BYTE cbName;
	CHAR szName[1];
} GEA, *PGEA;

#pragma pack(1)

typedef struct _GEA2 {
	ULONG oNextEntryOffset;
	BYTE cbName;
	CHAR szName[1];
} GEA2, *PGEA2;

typedef struct _GEA2LIST {
	ULONG cbList;
	GEA2 list[1];
} GEA2LIST, *PGEA2LIST;

#pragma pack(4)

typedef struct _GEALIST {
	ULONG cbList;
	GEA list[1];
} GEALIST, *PGEALIST;

typedef struct _EAOP {
	PGEALIST fpGEAList;
	PFEALIST fpFEAList;
	ULONG oError;
} EAOP, *PEAOP;

#pragma pack(1)

typedef struct _EAOP2 {
	PGEA2LIST fpGEA2List;
	PFEA2LIST fpFEA2List;
	ULONG oError;
} EAOP2, *PEAOP2;

#pragma pack(4)

typedef SHANDLE HDIR;
typedef HDIR *PHDIR;

#ifndef _HEV_DEFINED
#define _HEV_DEFINED
typedef ULONG HEV;
typedef HEV *PHEV;
#endif

typedef SHANDLE HFILE;
typedef HFILE *PHFILE;

typedef struct _SPOOLATTACH {
	USHORT hNmPipe;
	ULONG ulKey;
} SPOOLATTACH, *PSPOOLATTACH;

typedef struct _VOLUMELABEL {
	BYTE cch;
	CHAR szVolLabel[12];
} VOLUMELABEL, *PVOLUMELABEL;

typedef struct _FSINFO {
	FDATE fdateCreation;
	FTIME ftimeCreation;
	VOLUMELABEL vol;
} FSINFO, *PFSINFO;

ULONG DosCancelLockRequest(HFILE, PFILELOCK) asm ("DosCancelLockRequest");
ULONG DosClose(HFILE) asm ("DosClose");
ULONG DosCopy(PSZ, PSZ, ULONG) asm ("DosCopy");
ULONG DosCreateDir(PSZ, PEAOP2) asm ("DosCreateDir");
ULONG DosDelete(PSZ) asm ("DosDelete");
ULONG DosDeleteDir(PSZ) asm ("DosDeleteDir");
ULONG DosDupHandle(HFILE, PHFILE) asm ("DosDupHandle");
ULONG DosEditName(ULONG, PSZ, PSZ, PBYTE, ULONG) asm ("DosEditName");
ULONG DosEnumAttribute(ULONG, PVOID, ULONG, PVOID, ULONG, PULONG, ULONG) asm ("DosEnumAttribute");
ULONG DosFileIO(HFILE, PVOID, ULONG, PLONG) asm ("DosFileIO");
ULONG DosFindClose(HDIR) asm ("DosFindClose");
ULONG DosFindFirst(PSZ, PHDIR, ULONG, PVOID, ULONG, PULONG, ULONG) asm ("DosFindFirst");
ULONG DosFindNext(HDIR, PVOID, ULONG, PULONG) asm ("DosFindNext");
ULONG DosFSAttach(PSZ, PSZ, PVOID, ULONG, ULONG) asm ("DosFSAttach");
ULONG DosMove(PSZ, PSZ) asm ("DosMove");
ULONG DosOpen(PSZ, PHFILE, PULONG, ULONG, ULONG, ULONG, ULONG, PEAOP2) asm ("DosOpen");
ULONG DosFSCtl(PVOID, ULONG, PULONG, PVOID, ULONG, PULONG, ULONG, PSZ, HFILE, ULONG) asm ("DosFSCtl");
ULONG DosQueryCurrentDir(ULONG, PBYTE, PULONG) asm ("DosQueryCurrentDir");
ULONG DosQueryCurrentDisk(PULONG, PULONG) asm ("DosQueryCurrentDisk");
ULONG DosQueryFHState(HFILE, PULONG) asm ("DosQueryFHState");
ULONG DosQueryFileInfo(HFILE, ULONG, PVOID, ULONG) asm ("DosQueryFileInfo");
ULONG DosQueryFSAttach(PSZ, ULONG, ULONG, PFSQBUFFER2, PULONG) asm ("DosQueryFSAttach");
ULONG DosQueryFSInfo(ULONG, ULONG, PVOID, ULONG) asm ("DosQueryFSInfo");
ULONG DosQueryHType(HFILE, PULONG, PULONG) asm ("DosQueryHType");
ULONG DosQueryPathInfo(PSZ, ULONG, PVOID, ULONG) asm ("DosQueryPathInfo");
ULONG DosQueryVerify(PBOOL32) asm ("DosQueryVerify");
ULONG DosRead(HFILE, PVOID, ULONG, PULONG) asm ("DosRead");
ULONG DosResetBuffer(HFILE) asm ("DosResetBuffer");
ULONG DosSetCurrentDir(PSZ) asm ("DosSetCurrentDir");
ULONG DosSetDefaultDisk(ULONG) asm ("DosSetDefaultDisk");
ULONG DosSetFHState(HFILE, ULONG) asm ("DosSetFHState");
ULONG DosSetFileInfo(HFILE, ULONG, PVOID, ULONG) asm ("DosSetFileInfo");
ULONG DosSetFileLocks(HFILE, PFILELOCK, PFILELOCK, PHEV, ULONG, PULONG) asm ("DosSetFileLocks");
ULONG DosSetFilePtr(HFILE, LONG, ULONG, PULONG) asm ("DosSetFilePtr");
ULONG DosSetFileSize(HFILE, ULONG) asm ("DosSetFileSize");
ULONG DosSetFSInfo(ULONG, ULONG, PVOID, ULONG) asm ("DosSetFSInfo");
ULONG DosSetMaxFH(ULONG) asm ("DosSetMaxFH");
ULONG DosSetPathInfo(PSZ, ULONG, PVOID, ULONG, ULONG) asm ("DosSetPathInfo");
ULONG DosSetRelMaxFH(PLONG, PULONG) asm ("DosSetRelMaxFH");
ULONG DosSetVerify(BOOL32) asm ("DosSetVerify");
ULONG DosShutdown(ULONG) asm ("DosShutdown");
ULONG DosWrite(HFILE, PVOID, ULONG, PULONG) asm ("DosWrite");

#endif

#if (defined(INCL_DOSMEMMGR)||!defined(INCL_NOCOMMON))

ULONG DosAllocMem(PPVOID, ULONG, ULONG) asm ("DosAllocMem");
ULONG DosAllocSharedMem(PPVOID, PSZ, ULONG, ULONG) asm ("DosAllocSharedMem");
ULONG DosFreeMem(PVOID) asm ("DosFreeMem");
ULONG DosGetNamedSharedMem(PPVOID, PSZ, ULONG) asm ("DosGetNamedSharedMem");
ULONG DosGetSharedMem(PVOID, ULONG) asm ("DosGetSharedMem");
ULONG DosGiveSharedMem(PVOID, PID, ULONG) asm ("DosGiveSharedMem");
ULONG DosQueryMem(PVOID, PULONG, PULONG) asm ("DosQueryMem");
ULONG DosSetMem(PVOID, ULONG, ULONG) asm ("DosSetMem");
ULONG DosSubAllocMem(PVOID, PPVOID, ULONG) asm ("DosSubAllocMem");
ULONG DosSubFreeMem(PVOID, PVOID, ULONG) asm ("DosSubFreeMem");
ULONG DosSubSetMem(PVOID, ULONG, ULONG) asm ("DosSubSetMem");
ULONG DosSubUnsetMem(PVOID) asm ("DosSubUnsetMem");

#include <bsememf.h>

#endif

#if (defined(INCL_DOSSEMAPHORES)||!defined(INCL_NOCOMMON))

#define DC_SEM_SHARED					0x01

#define DCMW_WAIT_ANY					0x02
#define DCMW_WAIT_ALL					0x04

#ifndef _HSEM_DEFINED
#define _HSEM_DEFINED
typedef VOID *HSEM;
typedef HSEM *PHSEM;
#endif

#define SEM_INDEFINITE_WAIT				-1L
#define SEM_IMMEDIATE_RETURN				0L

typedef struct _PSEMRECORD {
	HSEM hsemCur;
	ULONG ulUser;
} SEMRECORD, *PSEMRECORD;

#endif


#ifdef INCL_DOSSEMAPHORES

#ifndef _HEV_DEFINED
#define _HEV_DEFINED
typedef ULONG HEV;
typedef HEV *PHEV;
#endif

typedef ULONG HMTX;
typedef HMTX *PHMTX;
typedef ULONG HMUX;
typedef HMUX *PHMUX;

ULONG DosAddMuxWaitSem(HMUX, PSEMRECORD) asm ("DosAddMuxWaitSem");
ULONG DosCloseEventSem(HEV) asm ("DosCloseEventSem");
ULONG DosCloseMutexSem(HMTX) asm ("DosCloseMutexSem");
ULONG DosCloseMuxWaitSem(HMUX) asm ("DosCloseMuxWaitSem");
ULONG DosCreateEventSem(PSZ, PHEV, ULONG, BOOL32) asm ("DosCreateEventSem");
ULONG DosCreateMutexSem(PSZ, PHMTX, ULONG, BOOL32) asm ("DosCreateMutexSem");
ULONG DosCreateMuxWaitSem(PSZ, PHMUX, ULONG, PSEMRECORD, ULONG) asm ("DosCreateMuxWaitSem");
ULONG DosDeleteMuxWaitSem(HMUX, HSEM) asm ("DosDeleteMuxWaitSem");
ULONG DosOpenEventSem(PSZ, PHEV) asm ("DosOpenEventSem");
ULONG DosOpenMutexSem(PSZ, PHMTX) asm ("DosOpenMutexSem");
ULONG DosOpenMuxWaitSem(PSZ, PHMUX) asm ("DosOpenMuxWaitSem");
ULONG DosPostEventSem(HEV) asm ("DosPostEventSem");
ULONG DosQueryEventSem(HEV, PULONG) asm ("DosQueryEventSem");
ULONG DosQueryMutexSem(HMTX, PID *, TID *, PULONG) asm ("DosQueryMutexSem");
ULONG DosQueryMuxWaitSem(HMUX, PULONG, PSEMRECORD, PULONG) asm ("DosQueryMuxWaitSem");
ULONG DosReleaseMutexSem(HMTX) asm ("DosReleaseMutexSem");
ULONG DosRequestMutexSem(HMTX, ULONG) asm ("DosRequestMutexSem");
ULONG DosResetEventSem(HEV, PULONG) asm ("DosResetEventSem");
ULONG DosWaitEventSem(HEV, ULONG) asm ("DosWaitEventSem");
ULONG DosWaitMuxWaitSem(HMUX, ULONG, PULONG) asm ("DosWaitMuxWaitSem");

#endif


#if (defined(INCL_DOSDATETIME)||!defined(INCL_NOCOMMON))

typedef struct _DATETIME {
	UCHAR hours;
	UCHAR minutes;
	UCHAR seconds;
	UCHAR hundredths;
	UCHAR day;
	UCHAR month;
	USHORT year;
	SHORT timezone;
	UCHAR weekday;
} DATETIME, *PDATETIME;

ULONG DosGetDateTime(PDATETIME) asm ("DosGetDateTime");
ULONG DosSetDateTime(PDATETIME) asm ("DosSetDateTime");

#endif

#ifdef INCL_DOSDATETIME

typedef SHANDLE HTIMER;
typedef HTIMER *PHTIMER;

ULONG DosAsyncTimer(ULONG, HSEM, PHTIMER) asm ("DosAsyncTimer");
ULONG DosStartTimer(ULONG, HSEM, PHTIMER) asm ("DosStartTimer");
ULONG DosStopTimer(HTIMER) asm ("DosStopTimer");

#endif

#ifdef INCL_DOSMODULEMGR

#define PT_16BIT					0
#define PT_32BIT					1

ULONG DosFreeModule(HMODULE) asm ("DosFreeModule");
ULONG DosLoadModule(PSZ, ULONG, PSZ, PHMODULE) asm ("DosLoadModule");
ULONG DosQueryModuleHandle(PSZ, PHMODULE) asm ("DosQueryModuleHandle");
ULONG DosQueryModuleName(HMODULE, ULONG, PCHAR) asm ("DosQueryModuleName");
ULONG DosQueryProcAddr(HMODULE, ULONG, PSZ, PFN*) asm ("DosQueryProcAddr");
ULONG DosQueryProcType(HMODULE, ULONG, PSZ, PULONG) asm ("DosQueryProcType");

#endif


#if (defined(INCL_DOSRESOURCES)||!defined(INCL_NOCOMMON))

#define RT_POINTER					1
#define RT_BITMAP					2
#define RT_MENU						3
#define RT_DIALOG					4
#define RT_STRING					5
#define RT_FONTDIR					6
#define RT_FONT						7
#define RT_ACCELTABLE					8
#define RT_RCDATA					9
#define RT_MESSAGE					10
#define RT_DLGINCLUDE					11
#define RT_VKEYTBL					12
#define RT_KEYTBL					13
#define RT_CHARTBL					14
#define RT_DISPLAYINFO					15
#define RT_FKASHORT					16
#define RT_FKALONG					17
#define RT_HELPTABLE					18
#define RT_HELPSUBTABLE					19
#define RT_FDDIR					20
#define RT_FD						21
#define RT_MAX						22
#define RF_ORDINALID					0x80000000L

#endif

#ifdef INCL_DOSRESOURCES

ULONG DosFreeResource(PVOID) asm ("DosFreeResource");
ULONG DosGetResource(HMODULE, ULONG, ULONG, PPVOID) asm ("DosGetResource");
ULONG DosQueryResourceSize(HMODULE, ULONG, ULONG, PULONG) asm ("DosQueryResourceSize");

#endif

#ifdef INCL_DOSNLS

typedef struct _COUNTRYCODE {
	ULONG country;
	ULONG codepage;
} COUNTRYCODE, *PCOUNTRYCODE;

typedef struct _COUNTRYINFO {
	ULONG country;
	ULONG codepage;
	ULONG fsDateFmt;
	CHAR szCurrency[5];
	CHAR szThousandsSeparator[2];
	CHAR szDecimal[2];
	CHAR szDateSeparator[2];
	CHAR szTimeSeparator[2];
	UCHAR fsCurrencyFmt;
	UCHAR cDecimalPlace;
	UCHAR fsTimeFmt;
	USHORT abReserved1[2];
	CHAR szDataSeparator[2];
	USHORT abReserved2[5];
} COUNTRYINFO, *PCOUNTRYINFO;

ULONG DosMapCase(ULONG, PCOUNTRYCODE, PCHAR) asm ("DosMapCase");
ULONG DosQueryCollate(ULONG, PCOUNTRYCODE, PCHAR, PULONG) asm ("DosQueryCollate");
ULONG DosQueryCp(ULONG, PULONG, PULONG) asm ("DosQueryCp");
ULONG DosQueryCtryInfo(ULONG, PCOUNTRYCODE, PCOUNTRYINFO, PULONG) asm ("DosQueryCtryInfo");
ULONG DosQueryDBCSEnv(ULONG, PCOUNTRYCODE, PCHAR) asm ("DosQueryDBCSEnv");
ULONG DosSetProcessCp(ULONG) asm ("DosSetProcessCp");

#endif

#ifdef INCL_DOSEXCEPTIONS

#include <bsexcpt.h>

#define SIG_UNSETFOCUS					0
#define SIG_SETFOCUS					1

ULONG DosAcknowledgeSignalException(ULONG) asm ("DosAcknowledgeSignalException");
ULONG DosEnterMustComplete(PULONG) asm ("DosEnterMustComplete");
ULONG DosExitMustComplete(PULONG) asm ("DosExitMustComplete");
ULONG DosRaiseException(PEXCEPTIONREPORTRECORD) asm ("DosRaiseException");
ULONG DosSendSignalException(PID, ULONG) asm ("DosSendSignalException");
ULONG DosSetExceptionHandler(PEXCEPTIONREGISTRATIONRECORD) asm ("DosSetExceptionHandler");
ULONG DosSetSignalExceptionFocus(BOOL32, PULONG) asm ("DosSetSignalExceptionFocus");
ULONG DosUnsetExceptionHandler(PEXCEPTIONREGISTRATIONRECORD) asm ("DosUnsetExceptionHandler");
ULONG DosUnwindException(PEXCEPTIONREGISTRATIONRECORD, PVOID, PEXCEPTIONREPORTRECORD) asm ("DosUnwindException");

#endif

#ifdef INCL_DOSQUEUES
#if (defined(INCL_DOSFILEMGR)||!defined(INCL_NOCOMMON))

#define QUE_FIFO					0L
#define QUE_LIFO					1L
#define QUE_PRIORITY					2L
#define QUE_NOCONVERT_ADDRESS				0L
#define QUE_CONVERT_ADDRESS				4L

typedef SHANDLE HQUEUE;
typedef HQUEUE *PHQUEUE;

typedef struct _REQUESTDATA {
	PID pid;
	ULONG ulData;
} REQUESTDATA, *PREQUESTDATA;

ULONG DosCloseQueue(HQUEUE) asm ("DosCloseQueue");
ULONG DosCreatePipe(PHFILE, PHFILE, ULONG) asm ("DosCreatePipe");
ULONG DosCreateQueue(PHQUEUE, ULONG, PSZ) asm ("DosCreateQueue");
ULONG DosOpenQueue(PPID, PHQUEUE, PSZ) asm ("DosOpenQueue");
ULONG DosPeekQueue(HQUEUE, PREQUESTDATA, PULONG, PPVOID, PULONG, BOOL32, PBYTE, HEV) asm ("DosPeekQueue");
ULONG DosPurgeQueue(HQUEUE) asm ("DosPurgeQueue");
ULONG DosQueryQueue(HQUEUE, PULONG) asm ("DosQueryQueue");
ULONG DosReadQueue(HQUEUE, PREQUESTDATA, PULONG, PPVOID, ULONG, BOOL32, PBYTE, HEV) asm ("DosReadQueue");
ULONG DosWriteQueue(HQUEUE, ULONG, ULONG, PVOID, ULONG) asm ("DosWriteQueue");

#endif
#endif

#ifdef INCL_DOSMISC

#define DSP_IMPLIEDCUR					1
#define DSP_PATHREF					2
#define DSP_IGNORENETERR				4

#define FERR_DISABLEHARDERR				0x00000000L
#define FERR_ENABLEHARDERR				0x00000001L
#define FERR_ENABLEEXCEPTION				0x00000000L
#define FERR_DISABLEEXCEPTION				0x00000002L

#define QSV_MAX_PATH_LENGTH				1
#define Q_MAX_PATH_LENGTH				QSV_MAX_PATH_LENGTH
#define QSV_MAX_TEXT_SESSIONS				2
#define QSV_MAX_PM_SESSIONS				3
#define QSV_MAX_VDM_SESSIONS				4
#define QSV_BOOT_DRIVE					5
#define QSV_DYN_PRI_VARIATION				6
#define QSV_MAX_WAIT					7
#define QSV_MIN_SLICE					8
#define QSV_MAX_SLICE					9
#define QSV_PAGE_SIZE					10
#define QSV_VERSION_MAJOR				11
#define QSV_VERSION_MINOR				12
#define QSV_VERSION_REVISION				13
#define QSV_MS_COUNT					14
#define QSV_TIME_LOW					15
#define QSV_TIME_HIGH					16
#define QSV_TOTPHYSMEM					17
#define QSV_TOTRESMEM					18
#define QSV_TOTAVAILMEM					19
#define QSV_MAXPRMEM					20
#define QSV_MAXSHMEM					21
#define QSV_TIMER_INTERVAL				22
#define QSV_MAX_COMP_LENGTH				23
#define QSV_MAX						QSV_MAX_COMP_LENGTH

ULONG DosErrClass(ULONG, PULONG, PULONG, PULONG) asm ("DosErrClass");
ULONG DosError(ULONG) asm ("DosError");;
ULONG DosGetMessage(PCHAR *, ULONG, PCHAR, ULONG, ULONG, PSZ, PULONG) asm ("DosGetMessage");
ULONG DosInsertMessage(PCHAR *, ULONG, PSZ, ULONG, PCHAR, ULONG, PULONG) asm ("DosInsertMessage");
ULONG DosPutMessage(HFILE, ULONG, PCHAR) asm ("DosPutMessage");
ULONG DosQueryMessageCP(PCHAR, ULONG, PSZ, PULONG) asm ("DosQueryMessageCP");
ULONG DosQuerySysInfo(ULONG, ULONG, PVOID, ULONG) asm ("DosQuerySysInfo");
ULONG DosScanEnv(PSZ, PSZ) asm ("DosScanEnv");
ULONG DosSearchPath(ULONG, PSZ, PSZ, PBYTE, ULONG) asm ("DosSearchPath");

#endif

#ifdef INCL_DOSSESMGR

#define SET_SESSION_UNCHANGED				0
#define SET_SESSION_SELECTABLE				1
#define SET_SESSION_NON_SELECTABLE			2
#define SET_SESSION_BOND				1
#define SET_SESSION_NO_BOND				2

#define SSF_RELATED_INDEPENDENT				0
#define SSF_RELATED_CHILD				1
#define SSF_FGBG_FORE					0
#define SSF_FGBG_BACK					1
#define SSF_TRACEOPT_NONE				0
#define SSF_TRACEOPT_TRACE				1
#define SSF_TRACEOPT_TRACEALL				2
#define SSF_INHERTOPT_SHELL				0
#define SSF_INHERTOPT_PARENT				1
#define SSF_TYPE_DEFAULT				0
#define SSF_TYPE_FULLSCREEN				1
#define SSF_TYPE_WINDOWABLEVIO				2
#define SSF_TYPE_PM					3
#define SSF_TYPE_VDM					4
#define SSF_TYPE_GROUP					5
#define SSF_TYPE_DLL					6
#define SSF_TYPE_WINDOWEDVDM				7
#define SSF_TYPE_PDD					8
#define SSF_TYPE_VDD					9
#define SSF_CONTROL_VISIBLE				0x0000
#define SSF_CONTROL_INVISIBLE				0x0001
#define SSF_CONTROL_MAXIMIZE				0x0002
#define SSF_CONTROL_MINIMIZE				0x0004
#define SSF_CONTROL_NOAUTOCLOSE				0x0008
#define SSF_CONTROL_SETPOS				0x8000

#define STOP_SESSION_SPECIFIED				0
#define STOP_SESSION_ALL				1

typedef struct _STARTDATA {
	USHORT Length;
	USHORT Related;
	USHORT FgBg;
	USHORT TraceOpt;
	PSZ PgmTitle;
	PSZ PgmName;
	PBYTE PgmInputs;
	PBYTE TermQ;
	PBYTE Environment;
	USHORT InheritOpt;
	USHORT SessionType;
	PSZ IconFile;
	ULONG PgmHandle;
	USHORT PgmControl;
	USHORT InitXPos;
	USHORT InitYPos;
	USHORT InitXSize;
	USHORT InitYSize;
	USHORT Reserved;
	PSZ ObjectBuffer;
	ULONG ObjectBuffLen;
} STARTDATA, *PSTARTDATA;

typedef struct _STATUSDATA {
	USHORT Length;
	USHORT SelectInd;
	USHORT BondInd;
} STATUSDATA, *PSTATUSDATA;

ULONG DosStartSession(PSTARTDATA, PULONG, PPID) asm ("DosStartSession");
ULONG DosSetSession(ULONG, PSTATUSDATA) asm ("DosSetSession");
ULONG DosSelectSession(ULONG) asm ("DosSelectSession");
ULONG DosStopSession(ULONG, ULONG) asm ("DosStopSession");
ULONG DosQueryAppType(PSZ, PULONG) asm ("DosQueryAppType");

#endif



#if (defined(INCL_DOSSESMGR)||defined(INCL_DOSFILEMGR))

#ifdef INCL_DOSFILEMGR

#define EAT_APPTYP_PMAPI				0x00
#define EAT_APPTYP_DOS					0x01
#define EAT_APPTYP_PMW					0x02
#define EAT_APPTYP_NOPMW				0x03
#define EAT_APPTYP_EXETYPE				0x03
#define EAT_APPTYP_RESERVED				~(EAT_APPTYP_EXETYPE)

#endif

#define FAPPTYP_NOTSPEC					0x0000
#define FAPPTYP_NOTWINDOWCOMPAT				0x0001
#define FAPPTYP_WINDOWCOMPAT				0x0002
#define FAPPTYP_WINDOWAPI				0x0003
#define FAPPTYP_BOUND					0x0008
#define FAPPTYP_DLL					0x0010
#define FAPPTYP_DOS					0x0020
#define FAPPTYP_PHYSDRV					0x0040
#define FAPPTYP_VIRTDRV					0x0080
#define FAPPTYP_PROTDLL					0x0100
#define FAPPTYP_WINDOWSREAL				0x0200
#define FAPPTYP_WINDOWSPROT				0x0400
#define FAPPTYP_32BIT					0x4000
#define FAPPTYP_EXETYPE					FAPPTYP_WINDOWAPI
#define FAPPTYP_RESERVED				~(FAPPTYP_WINDOWAPI | FAPPTYP_BOUND | FAPPTYP_DLL | FAPPTYP_DOS | FAPPTYP_PHYSDRV | FAPPTYP_VIRTDRV | FAPPTYP_PROTDLL | FAPPTYP_32BIT)

#endif

#ifdef INCL_DOSDEVICES

#define DEVINFO_PRINTER					0
#define DEVINFO_RS232					1
#define DEVINFO_FLOPPY					2
#define DEVINFO_COPROCESSOR				3
#define DEVINFO_SUBMODEL				4
#define DEVINFO_MODEL					5
#define DEVINFO_ADAPTER					6

#define INFO_COUNT_PARTITIONABLE_DISKS			1
#define INFO_GETIOCTLHANDLE				2
#define INFO_FREEIOCTLHANDLE				3

ULONG DosDevConfig(PVOID, ULONG) asm ("DosDevConfig");
ULONG DosDevIOCtl(HFILE, ULONG, ULONG, PVOID, ULONG, PULONG, PVOID, ULONG, PULONG) asm ("DosDevIOCtl");
ULONG DosPhysicalDisk(ULONG, PVOID, ULONG, PVOID, ULONG) asm ("DosPhysicalDisk");

#endif

#ifdef INCL_DOSNMPIPES

#define NP_INDEFINITE_WAIT				-1
#define NP_DEFAULT_WAIT					0L
#define NP_STATE_DISCONNECTED				0x0001
#define NP_STATE_LISTENING				0x0002
#define NP_STATE_CONNECTED				0x0003
#define NP_STATE_CLOSING				0x0004
#define NP_ACCESS_INBOUND				0x0000
#define NP_ACCESS_OUTBOUND				0x0001
#define NP_ACCESS_DUPLEX				0x0002
#define NP_INHERIT					0x0000
#define NP_NOINHERIT					0x0080
#define NP_WRITEBEHIND					0x0000
#define NP_NOWRITEBEHIND				0x4000
#define NP_READMODE_BYTE				0x0000
#define NP_READMODE_MESSAGE				0x0100
#define NP_TYPE_BYTE					0x0000
#define NP_TYPE_MESSAGE					0x0400
#define NP_END_CLIENT					0x0000
#define NP_END_SERVER					0x4000
#define NP_WAIT						0x0000
#define NP_NOWAIT					0x8000
#define NP_UNLIMITED_INSTANCES				0x00FF
#define NP_NBLK						0x8000
#define NP_SERVER					0x4000
#define NP_WMESG					0x0400
#define NP_RMESG					0x0100
#define NP_ICOUNT					0x00FF
#define NP_DISCONNECTED					1
#define NP_LISTENING					2
#define NP_CONNECTED					3
#define NP_CLOSING					4

#define NPSS_EOI					0
#define NPSS_RDATA					1
#define NPSS_WSPACE					2
#define NPSS_CLOSE					3
#define NPSS_WAIT					0x01

typedef struct _AVAILDATA {
	USHORT cbpipe;
	USHORT cbmessage;
} AVAILDATA, *PAVAILDATA;

typedef SHANDLE HPIPE;
typedef HPIPE *PHPIPE;

typedef struct _PIPEINFO {
	USHORT cbOut;
	USHORT cbIn;
	BYTE cbMaxInst;
	BYTE cbCurInst;
	BYTE cbName;
	CHAR szName[1];
} PIPEINFO, *PPIPEINFO;

typedef struct _PIPESEMSTATE {
	BYTE fStatus;
	BYTE fFlag;
	USHORT usKey;
	USHORT usAvail;
} PIPESEMSTATE, *PPIPESEMSTATE;

ULONG DosCallNPipe(PSZ, PVOID, ULONG, PVOID, ULONG, PULONG, ULONG) asm ("DosCallNPipe");
ULONG DosConnectNPipe(HPIPE) asm ("DosConnectNPipe");
ULONG DosCreateNPipe(PSZ, PHPIPE, ULONG, ULONG, ULONG, ULONG, ULONG) asm ("DosCreateNPipe");
ULONG DosDisConnectNPipe(HPIPE) asm ("DosDisConnectNPipe");
ULONG DosPeekNPipe(HPIPE, PVOID, ULONG, PULONG, PAVAILDATA, PULONG) asm ("DosPeekNPipe");
ULONG DosQueryNPHState(HPIPE, PULONG) asm ("DosQueryNPHState");
ULONG DosQueryNPipeInfo(HPIPE, ULONG, PVOID, ULONG) asm ("DosQueryNPipeInfo");
ULONG DosQueryNPipeSemState(HSEM, PPIPESEMSTATE, ULONG) asm ("DosQueryNPipeSemState");
ULONG DosRawReadNPipe(PSZ, ULONG, PULONG, PVOID) asm ("DosRawReadNPipe");
ULONG DosRawWriteNPipe(PSZ, ULONG) asm ("DosRawWriteNPipe");
ULONG DosSetNPHState(HPIPE, ULONG) asm ("DosSetNPHState");
ULONG DosSetNPipeSem(HPIPE, HSEM, ULONG) asm ("DosSetNPipeSem");
ULONG DosTransactNPipe(HPIPE, PVOID, ULONG, PVOID, ULONG, PULONG) asm ("DosTransactNPipe");
ULONG DosWaitNPipe(PSZ, ULONG) asm ("DosWaitNPipe");

#endif

#ifdef INCL_DOSPROFILE

#define PROF_ORDINAL					133
#define PROF_SYSTEM					0
#define PROF_USER					1
#define PROF_USEDD					2
#define PROF_KERNEL					4
#define PROF_VERBOSE					8
#define PROF_ENABLE					16
#define PROF_ALLOC					0
#define PROF_CLEAR					1
#define PROF_ON						2
#define PROF_OFF					3
#define PROF_DUMP					4
#define PROF_FREE					5
#define PROF_SHIFT					2
#define PROF_MOD_NAME_SIZE				10
#define PROF_END_OF_DATA				13

ULONG DosTmrQueryFreq(PULONG) asm ("DosTmrQueryFreq");
ULONG DosTmrQueryTime(PQWORD) asm ("DosTmrQueryTime");
ULONG DosRegisterPerfCtrs(PBYTE, PBYTE, ULONG) asm ("DosRegisterPerfCtrs");

#endif

#ifdef INCL_DOSMVDM

typedef LHANDLE HVDD;
typedef HVDD *PHVDD;

ULONG DosOpenVDD(PSZ, PHVDD) asm ("DosOpenVDD");
ULONG DosRequestVDD(HVDD, SGID, ULONG, ULONG, PVOID, ULONG, PVOID) asm ("DosRequestVDD");
ULONG DosCloseVDD(HVDD) asm ("DosCloseVDD");
ULONG DosQueryDOSProperty(SGID, PSZ, ULONG, PSZ) asm ("DosQueryDOSProperty");
ULONG DosSetDOSProperty(SGID, PSZ, ULONG, PSZ) asm ("DosSetDOSProperty");

#endif

