#define OS2DEF_INCLUDED

#define APIENTRY
#define EXPENTRY

#define CHAR  char
#define INT   int
#define LONG  long
#define SHORT short
#define VOID  void

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef NULL
#define NULL ((void *)0)
#endif

#define ADDRESS 0

#define FACESIZE 32

#define FATTR_SEL_ITALIC            0x0001
#define FATTR_SEL_UNDERSCORE        0x0002
#define FATTR_SEL_OUTLINE           0x0008
#define FATTR_SEL_STRIKEOUT         0x0010
#define FATTR_SEL_BOLD              0x0020
#define FATTR_TYPE_KERNING          0x0004
#define FATTR_TYPE_MBCS             0x0008
#define FATTR_TYPE_DBCS             0x0010
#define FATTR_TYPE_ANTIALIASED      0x0020
#define FATTR_FONTUSE_NOMIX         0x0002
#define FATTR_FONTUSE_OUTLINE       0x0004
#define FATTR_FONTUSE_TRANSFORMABLE 0x0008

#define FM_TYPE_FIXED     0x0001
#define FM_TYPE_LICENSED  0x0002
#define FM_TYPE_KERNING   0x0004
#define FM_TYPE_DBCS      0x0010
#define FM_TYPE_MBCS      0x0018
#define FM_TYPE_64K       0x8000
#define FM_DEFN_OUTLINE   0x0001
#define FM_DEFN_IFI       0x0002
#define FM_DEFN_WIN       0x0004
#define FM_DEFN_GENERIC   0x8000
#define FM_SEL_ITALIC     0x0001
#define FM_SEL_UNDERSCORE 0x0002
#define FM_SEL_NEGATIVE   0x0004
#define FM_SEL_OUTLINE    0x0008
#define FM_SEL_STRIKEOUT  0x0010
#define FM_SEL_BOLD       0x0020
#define FM_CAP_NOMIX      0x0001

#define SEVERITY_NOERROR       0x0000
#define SEVERITY_WARNING       0x0004
#define SEVERITY_ERROR         0x0008
#define SEVERITY_SEVERE        0x000C
#define SEVERITY_UNRECOVERABLE 0x0010

#define WINERR_BASE 0x1000
#define GPIERR_BASE 0x2000
#define DEVERR_BASE 0x3000
#define SPLERR_BASE 0x4000

#define DRIVER_NAME    1
#define DRIVER_DATA    2
#define DATA_TYPE      3
#define COMMENT        4
#define PROC_NAME      5
#define PROC_PARAMS    6
#define SPL_PARAMS     7
#define NETWORK_PARAMS 8

#define ERRORIDERROR(errid)      (LOUSHORT(errid))
#define ERRORIDSEV(errid)        (HIUSHORT(errid))
#define FIELDOFFSET(type, field) ((SHORT)&(((type *)0)->field))
#define HIBYTE(w)                HIUCHAR(w)
#define HIUCHAR(w)               ((UCHAR)(((USHORT)(w) >> 8) & 0xff))
#define HIUSHORT(l)              ((USHORT)(((ULONG)(l) >> 16) & 0xffff))
#define LOBYTE(w)                LOUCHAR(w)
#define LOUCHAR(w)               ((UCHAR)(w))
#define LOUSHORT(l)              ((USHORT)(l))
#define MAKEERRORID(sev,error)   (ERRORID)(MAKEULONG((error),(sev)))
#define MAKELONG(l,h)            ((LONG)MAKEULONG(l, h))
#define MAKESHORT(l,h)           ((SHORT)MAKEUSHORT(l, h))
#define MAKETYPE(v,type)         (*((type *)&v))
#define MAKEULONG(l,h)           ((ULONG)(((USHORT)(l))|((ULONG)((USHORT)(h)))<<16))
#define MAKEUSHORT(l,h)          (((USHORT)(l))|((USHORT)(h))<<8)

typedef unsigned short BOOL;
typedef unsigned long BOOL32;
typedef unsigned char BYTE;
#ifndef _HSEM_DEFINED
#define _HSEM_DEFINED
typedef VOID *HSEM;
typedef HSEM *PHSEM;
#endif
typedef VOID *LHANDLE;
typedef BYTE *NPBYTE;
typedef unsigned char *NPCH;
typedef int _NPFN();
typedef _NPFN *NPFN;
typedef unsigned char *NPSZ;
typedef BOOL *PBOOL;
typedef BOOL32 *PBOOL32;
typedef BYTE *PBYTE;
typedef unsigned char *PCH;
typedef CHAR *PCHAR;
typedef int _PFN();
typedef _PFN *PFN;
typedef INT *PINT;
typedef LONG *PLONG;
typedef SHORT *PSHORT;
typedef unsigned char *PSZ;
typedef VOID *PVOID;
typedef unsigned short SEL;
typedef unsigned long SHANDLE;
typedef unsigned char UCHAR;
typedef unsigned int UINT;
typedef unsigned long ULONG;
typedef unsigned short USHORT;
typedef ULONG ERRORID;
typedef ERRORID *PERRORID;

typedef LONG COLOR;
typedef LHANDLE HAB;
typedef LHANDLE HBITMAP;
typedef LHANDLE HDC;
typedef LHANDLE HMF;
typedef SHANDLE HMODULE;
typedef LHANDLE HPAL;
typedef LHANDLE HPS;
typedef LHANDLE HRGN;
typedef LHANDLE HWND;
typedef COLOR *PCOLOR;
typedef HAB *PHAB;
typedef HBITMAP *PHBITMAP;
typedef HDC *PHDC;
typedef HMF *PHMF;
typedef HMODULE *PHMODULE;
typedef HPAL *PHPAL;
typedef HPS *PHPS;
typedef HRGN *PHRGN;
typedef HWND *PHWND;
typedef SHANDLE PID;
typedef PID *PPID;
typedef PVOID *PPVOID;
typedef SEL *PSEL;
typedef UCHAR *PUCHAR;
typedef UINT *PUINT;
typedef ULONG *PULONG;
typedef USHORT *PUSHORT;
typedef USHORT SGID;
typedef CHAR STR8[8];
typedef SHANDLE TID;

typedef STR8 *PSTR8;
typedef TID *PTID;

typedef struct _DRIVDATA {
	LONG cb;
	LONG lVersion;
	CHAR szDeviceName[32];
	CHAR abGeneralData[1];
} DRIVDATA, *PDRIVDATA;

typedef struct _DEVOPENSTRUC {
	PSZ       pszLogAddress;
	PSZ       pszDriverName;
	PDRIVDATA pdriv;
	PSZ       pszDataType;
	PSZ       pszComment;
	PSZ       pszQueueProcName;
	PSZ       pszQueueProcParams;
	PSZ       pszSpoolerParams;
	PSZ       pszNetworkParams;
} DEVOPENSTRUC, *PDEVOPENSTRUC;

typedef struct _FATTRS {
	USHORT usRecordLength;
	USHORT fsSelection;
	LONG   lMatch;
	CHAR   szFacename[FACESIZE];
	USHORT idRegistry;
	USHORT usCodePage;
	LONG   lMaxBaselineExt;
	LONG   lAveCharWidth;
	USHORT fsType;
	USHORT fsFontUse;
} FATTRS, *PFATTRS;

typedef struct _PANOSE {
	BYTE bFamilyType;
	BYTE bSerifStyle;
	BYTE bWeight;
	BYTE bProportion;
	BYTE bContrast;
	BYTE bStrokeVariation;
	BYTE bArmStyle;
	BYTE bLetterform;
	BYTE bMidline;
	BYTE bXHeight;
	BYTE abReserved[2];
} PANOSE;

typedef struct _POINTL {
	LONG x;
	LONG y;
} POINTL, *PPOINTL, *NPPOINTL;

typedef struct _POINTS {
	SHORT x;
	SHORT y;
} POINTS, *PPOINTS;

typedef struct _QWORD {
	ULONG ulLo;
	ULONG ulHi;
} QWORD, *PQWORD;

typedef struct _RECTL {
	LONG xLeft;
	LONG yBottom;
	LONG xRight;
	LONG yTop;
} RECTL, *PRECTL, *NPRECTL;

typedef struct _FONTMETRICS {
	CHAR   szFamilyname[FACESIZE];
	CHAR   szFacename[FACESIZE];
	USHORT idRegistry;
	USHORT usCodePage;
	LONG   lEmHeight;
	LONG   lXHeight;
	LONG   lMaxAscender;
	LONG   lMaxDescender;
	LONG   lLowerCaseAscent;
	LONG   lLowerCaseDescent;
	LONG   lInternalLeading;
	LONG   lExternalLeading;
	LONG   lAveCharWidth;
	LONG   lMaxCharInc;
	LONG   lEmInc;
	LONG   lMaxBaselineExt;
	SHORT  sCharSlope;
	SHORT  sInlineDir;
	SHORT  sCharRot;
	USHORT usWeightClass;
	USHORT usWidthClass;
	SHORT  sXDeviceRes;
	SHORT  sYDeviceRes;
	SHORT  sFirstChar;
	SHORT  sLastChar;
	SHORT  sDefaultChar;
	SHORT  sBreakChar;
	SHORT  sNominalPointSize;
	SHORT  sMinimumPointSize;
	SHORT  sMaximumPointSize;
	USHORT fsType;
	USHORT fsDefn;
	USHORT fsSelection;
	USHORT fsCapabilities;
	LONG   lSubscriptXSize;
	LONG   lSubscriptYSize;
	LONG   lSubscriptXOffset;
	LONG   lSubscriptYOffset;
	LONG   lSuperscriptXSize;
	LONG   lSuperscriptYSize;
	LONG   lSuperscriptXOffset;
	LONG   lSuperscriptYOffset;
	LONG   lUnderscoreSize;
	LONG   lUnderscorePosition;
	LONG   lStrikeoutSize;
	LONG   lStrikeoutPosition;
	SHORT  sKerningPairs;
	SHORT  sFamilyClass;
	LONG   lMatch;
	PANOSE panose;
} FONTMETRICS, *PFONTMETRICS;

typedef struct _WPOINT {
	SHORT x;
	SHORT dummy1;
	SHORT y;
	SHORT dummy2;
} WPOINT, *PWPOINT, *NPWPOINT;

typedef struct _WRECT {
	SHORT xLeft;
	SHORT dummy1;
	SHORT yBottom;
	SHORT dummy2;
	SHORT xRight;
	SHORT dummy3;
	SHORT yTop;
	SHORT dummy4;
} WRECT, *PWRECT, *NPWRECT;

