#define BBO_OR						0L
#define BBO_AND						1L
#define BBO_IGNORE					2L

#define FF_BOUNDARY					0L
#define FF_SURFACE					1L

#define HBM_ERROR					((HBITMAP)-1L)

#define ROP_SRCCOPY					0x00CCL
#define ROP_SRCPAINT					0x00EEL
#define ROP_SRCAND					0x0088L
#define ROP_SRCINVERT					0x0066L
#define ROP_SRCERASE					0x0044L
#define ROP_NOTSRCCOPY					0x0033L
#define ROP_NOTSRCERASE					0x0011L
#define ROP_MERGECOPY					0x00C0L
#define ROP_MERGEPAINT					0x00BBL
#define ROP_PATCOPY					0x00F0L
#define ROP_PATPAINT					0x00FBL
#define ROP_PATINVERT					0x005AL
#define ROP_DSTINVERT					0x0055L
#define ROP_ZERO					0x0000L
#define ROP_ONE						0x00FFL


#ifdef INCL_GPIBITMAPS

#define BCA_UNCOMP					0L
#define BCA_HUFFMAN1D					3L
#define BCA_RLE4					2L
#define BCA_RLE8					1L
#define BCA_RLE24					4L

#define BCE_PALETTE					-1L
#define BCE_RGB						0L

#define BFT_ICON					0x4349
#define BFT_BMAP					0x4d42
#define BFT_POINTER					0x5450
#define BFT_COLORICON					0x4943
#define BFT_COLORPOINTER				0x5043
#define BFT_BITMAPARRAY					0x4142

#define BMB_ERROR					(-1L)

#define BRA_BOTTOMUP					0L

#define BRH_NOTHALFTONED				0L
#define BRH_ERRORDIFFUSION				1L
#define BRH_PANDA					2L
#define BRH_SUPERCIRCLE					3L

#define BRU_METRIC					0L

#define CBD_COMPRESSION					1L
#define CBD_DECOMPRESSION				2L
#define CBD_BITS					0L
#define CBD_COLOR_CONVERSION				0x00000001L

#define CBM_INIT					0x0004L

#pragma pack(2)

typedef struct _BITMAPINFOHEADER {
	ULONG cbFix;
	USHORT cx;
	USHORT cy;
	USHORT cPlanes;
	USHORT cBitCount;
} BITMAPINFOHEADER, *PBITMAPINFOHEADER;

typedef struct _BITMAPFILEHEADER {
	USHORT usType;
	ULONG cbSize;
	SHORT xHotspot;
	SHORT yHotspot;
	ULONG offBits;
	BITMAPINFOHEADER bmp;
} BITMAPFILEHEADER, *PBITMAPFILEHEADER;

typedef struct _BITMAPARRAYFILEHEADER {
	USHORT usType;
	ULONG cbSize;
	ULONG offNext;
	USHORT cxDisplay;
	USHORT cyDisplay;
	BITMAPFILEHEADER bfh;
} BITMAPARRAYFILEHEADER, *PBITMAPARRAYFILEHEADER;

typedef struct _BITMAPINFOHEADER2 {
	ULONG cbFix;
	ULONG cx;
	ULONG cy;
	USHORT cPlanes;
	USHORT cBitCount;
	ULONG ulCompression;
	ULONG cbImage;
	ULONG cxResolution;
	ULONG cyResolution;
	ULONG cclrUsed;
	ULONG cclrImportant;
	USHORT usUnits;
	USHORT usReserved;
	USHORT usRecording;
	USHORT usRendering;
	ULONG cSize1;
	ULONG cSize2;
	ULONG ulColorEncoding;
	ULONG ulIdentifier;
} BITMAPINFOHEADER2, *PBITMAPINFOHEADER2;

typedef struct _BITMAPFILEHEADER2 {
	USHORT usType;
	ULONG cbSize;
	SHORT xHotspot;
	SHORT yHotspot;
	ULONG offBits;
	BITMAPINFOHEADER2 bmp2;
} BITMAPFILEHEADER2, *PBITMAPFILEHEADER2;

typedef struct _BITMAPARRAYFILEHEADER2 {
	USHORT usType;
	ULONG cbSize;
	ULONG offNext;
	USHORT cxDisplay;
	USHORT cyDisplay;
	BITMAPFILEHEADER2 bfh2;
} BITMAPARRAYFILEHEADER2, *PBITMAPARRAYFILEHEADER2;

typedef struct _RGB {
	BYTE bBlue;
	BYTE bGreen;
	BYTE bRed;
} RGB;

typedef struct _BITMAPINFO {
	ULONG cbFix;
	USHORT cx;
	USHORT cy;
	USHORT cPlanes;
	USHORT cBitCount;
	RGB argbColor[1];
} BITMAPINFO, *PBITMAPINFO;

typedef struct _RGB2 {
	BYTE bBlue;
	BYTE bGreen;
	BYTE bRed;
	BYTE fcOptions;
} RGB2, *PRGB2;

typedef struct _BITMAPINFO2 {
	ULONG cbFix;
	ULONG cx;
	ULONG cy;
	USHORT cPlanes;
	USHORT cBitCount;
	ULONG ulCompression;
	ULONG cbImage;
	ULONG cxResolution;
	ULONG cyResolution;
	ULONG cclrUsed;
	ULONG cclrImportant;
	USHORT usUnits;
	USHORT usReserved;
	USHORT usRecording;
	USHORT usRendering;
	ULONG cSize1;
	ULONG cSize2;
	ULONG ulColorEncoding;
	ULONG ulIdentifier;
	RGB2 argbColor[1];
} BITMAPINFO2, *PBITMAPINFO2;

#pragma pack(4)

#endif

