#define CDEF_GENERIC					0x0001
#define CDEF_BOLD					0x0002
#define CDEF_ITALIC					0x0004
#define CDEF_UNDERSCORE					0x0008
#define CDEF_STRIKEOUT					0x0010
#define CDEF_OUTLINE					0x0020

#define FONT_SIGNATURE					0xfffffffe
#define FONT_METRICS					0x00000001
#define FONT_DEFINITION					0x00000002
#define FONT_KERNPAIRS					0x00000003
#define FONT_ADDITIONALMETRICS				0x00000004
#define FONT_ENDRECORD					0xffffffff

#define FONTDEFFONT1					0x0047
#define FONTDEFFONT2					0x0042
#define FONTDEFFONT3					0x0042
#define FONTDEFCHAR1					0x0081
#define FONTDEFCHAR2					0x0081
#define FONTDEFCHAR3					0x00b8

#define QUERY_PUBLIC_FONTS				0x0001
#define QUERY_PRIVATE_FONTS				0x0002

#define SPACE_UNDEF					0x8000

typedef struct _ADDITIONALMETRICS {
	ULONG ulIdentity;
	ULONG ulSize;
	PANOSE panose;
} ADDITIONALMETRICS, *PADDITIONALMETRICS;

typedef struct _FOCAMETRICS {
	ULONG ulIdentity;
	ULONG ulSize;
	CHAR szFamilyname[32];
	CHAR szFacename[32];
	SHORT usRegistryId;
	SHORT usCodePage;
	SHORT yEmHeight;
	SHORT yXHeight;
	SHORT yMaxAscender;
	SHORT yMaxDescender;
	SHORT yLowerCaseAscent;
	SHORT yLowerCaseDescent;
	SHORT yInternalLeading;
	SHORT yExternalLeading;
	SHORT xAveCharWidth;
	SHORT xMaxCharInc;
	SHORT xEmInc;
	SHORT yMaxBaselineExt;
	SHORT sCharSlope;
	SHORT sInlineDir;
	SHORT sCharRot;
	USHORT usWeightClass;
	USHORT usWidthClass;
	SHORT xDeviceRes;
	SHORT yDeviceRes;
	SHORT usFirstChar;
	SHORT usLastChar;
	SHORT usDefaultChar;
	SHORT usBreakChar;
	SHORT usNominalPointSize;
	SHORT usMinimumPointSize;
	SHORT usMaximumPointSize;
	SHORT fsTypeFlags;
	SHORT fsDefn;
	SHORT fsSelectionFlags;
	SHORT fsCapabilities;
	SHORT ySubscriptXSize;
	SHORT ySubscriptYSize;
	SHORT ySubscriptXOffset;
	SHORT ySubscriptYOffset;
	SHORT ySuperscriptXSize;
	SHORT ySuperscriptYSize;
	SHORT ySuperscriptXOffset;
	SHORT ySuperscriptYOffset;
	SHORT yUnderscoreSize;
	SHORT yUnderscorePosition;
	SHORT yStrikeoutSize;
	SHORT yStrikeoutPosition;
	SHORT usKerningPairs;
	SHORT sFamilyClass;
	PSZ pszDeviceNameOffset;
} FOCAMETRICS, *PFOCAMETRICS;

typedef struct _FONTDEFINITIONHEADER {
	ULONG ulIdentity;
	ULONG ulSize;
	SHORT fsFontdef;
	SHORT fsChardef;
	SHORT usCellSize;
	SHORT xCellWidth;
	SHORT yCellHeight;
	SHORT xCellIncrement;
	SHORT xCellA;
	SHORT xCellB;
	SHORT xCellC;
	SHORT pCellBaseOffset;
} FONTDEFINITIONHEADER, *PFONTDEFINITIONHEADER;

typedef struct _FONTFILEMETRICS {
	ULONG ulIdentity;
	ULONG ulSize;
	CHAR szFamilyname[32];
	CHAR szFacename[32];
	SHORT usRegistryId;
	SHORT usCodePage;
	SHORT yEmHeight;
	SHORT yXHeight;
	SHORT yMaxAscender;
	SHORT yMaxDescender;
	SHORT yLowerCaseAscent;
	SHORT yLowerCaseDescent;
	SHORT yInternalLeading;
	SHORT yExternalLeading;
	SHORT xAveCharWidth;
	SHORT xMaxCharInc;
	SHORT xEmInc;
	SHORT yMaxBaselineExt;
	SHORT sCharSlope;
	SHORT sInlineDir;
	SHORT sCharRot;
	USHORT usWeightClass;
	USHORT usWidthClass;
	SHORT xDeviceRes;
	SHORT yDeviceRes;
	SHORT usFirstChar;
	SHORT usLastChar;
	SHORT usDefaultChar;
	SHORT usBreakChar;
	SHORT usNominalPointSize;
	SHORT usMinimumPointSize;
	SHORT usMaximumPointSize;
	SHORT fsTypeFlags;
	SHORT fsDefn;
	SHORT fsSelectionFlags;
	SHORT fsCapabilities;
	SHORT ySubscriptXSize;
	SHORT ySubscriptYSize;
	SHORT ySubscriptXOffset;
	SHORT ySubscriptYOffset;
	SHORT ySuperscriptXSize;
	SHORT ySuperscriptYSize;
	SHORT ySuperscriptXOffset;
	SHORT ySuperscriptYOffset;
	SHORT yUnderscoreSize;
	SHORT yUnderscorePosition;
	SHORT yStrikeoutSize;
	SHORT yStrikeoutPosition;
	SHORT usKerningPairs;
	SHORT sFamilyClass;
	ULONG ulReserved;
	PANOSE panose;
} FONTFILEMETRICS, *PFONTFILEMETRICS;

typedef struct _FONTSIGNATURE {
	ULONG ulIdentity;
	ULONG ulSize;
	CHAR achSignature[12];
} FONTSIGNATURE, *PFONTSIGNATURE;

typedef struct _FOCAFONT {
	FONTSIGNATURE fsSignature;
	FOCAMETRICS fmMetrics;
	FONTDEFINITIONHEADER fdDefinitions;
} FOCAFONT, *PFOCAFONT;

