#ifdef INCL_ERRORS
#define INCL_GPIERRORS
#endif

#ifdef INCL_GPI
#define INCL_GPICONTROL
#define INCL_GPICORRELATION
#define INCL_GPISEGMENTS
#define INCL_GPISEGEDITING
#define INCL_GPITRANSFORMS
#define INCL_GPIPATHS
#define INCL_GPILOGCOLORTABLE
#define INCL_GPIPRIMITIVES
#define INCL_GPILCIDS
#define INCL_GPIBITMAPS
#define INCL_GPIREGIONS
#define INCL_GPIMETAFILES
#define INCL_GPIDEFAULTS
#endif

#define CLR_NOINDEX					(-254L)

#define GPI_ERROR					0L
#define GPI_OK						1L
#define GPI_ALTERROR					(-1L)

#define FIXEDFRAC(fx) (LOUSHORT(fx))
#define FIXEDINT(fx) ((SHORT)HIUSHORT(fx))
#define MAKEFIXED(intpart,fractpart) MAKELONG(fractpart,intpart)

typedef LONG FIXED;
typedef USHORT FIXED114;
typedef USHORT FIXED88;
typedef FIXED *PFIXED;

#pragma pack(2)

typedef struct _SIZEL {
	LONG cx;
	LONG cy;
} SIZEL, *PSIZEL;

#pragma pack(4)

#if (defined(INCL_GPICONTROL)||!defined(INCL_NOCOMMON))

#define GPIA_NOASSOC					0L
#define GPIA_ASSOC					0x4000L

#define GPIF_DEFAULT					0L
#define GPIF_SHORT					0x0100L
#define GPIF_LONG					0x0200L

#define GPIT_NORMAL					0L
#define GPIT_MICRO					0x1000L

#define HDC_ERROR					((HDC)-1L)

#define PU_ARBITRARY					0x0004L
#define PU_PELS						0x0008L
#define PU_LOMETRIC					0x000CL
#define PU_HIMETRIC					0x0010L
#define PU_LOENGLISH					0x0014L
#define PU_HIENGLISH					0x0018L
#define PU_TWIPS					0x001CL

BOOL GpiAssociate(HPS, HDC) asm ("GpiAssociate");
HPS GpiCreatePS(HAB, HDC, PSIZEL, ULONG) asm ("GpiCreatePS");
BOOL GpiDestroyPS(HPS) asm ("GpiDestroyPS");
BOOL GpiErase(HPS) asm ("GpiErase");
HDC GpiQueryDevice(HPS) asm ("GpiQueryDevice");
BOOL GpiRestorePS(HPS, LONG) asm ("GpiRestorePS");
LONG GpiSavePS(HPS) asm ("GpiSavePS");

#endif


#ifdef INCL_GPICONTROL

#define DCTL_ERASE					1L
#define DCTL_DISPLAY					2L
#define DCTL_BOUNDARY					3L
#define DCTL_DYNAMIC					4L
#define DCTL_CORRELATE					5L
#define DCTL_ERROR					-1L
#define DCTL_OFF					0L
#define DCTL_ON						1L

#define DM_ERROR					0L
#define DM_DRAW						1L
#define DM_RETAIN					2L
#define DM_DRAWANDRETAIN				3L

#define GPIE_SEGMENT					0L
#define GPIE_ELEMENT					1L
#define GPIE_DATA					2L

#define GRES_ATTRS					0x0001L
#define GRES_SEGMENTS					0x0002L
#define GRES_ALL					0x0004L

#define PS_UNITS					0x00FCL
#define PS_FORMAT					0x0F00L
#define PS_TYPE						0x1000L
#define PS_MODE						0x2000L
#define PS_ASSOCIATE					0x4000L
#define PS_NORESET					0x8000L

#define SDW_ERROR					-1L
#define SDW_OFF						0L
#define SDW_ON						1L

LONG GpiErrorSegmentData(HPS, PLONG, PLONG) asm ("GpiErrorSegmentData");
LONG GpiQueryDrawControl(HPS, LONG) asm ("GpiQueryDrawControl");
LONG GpiQueryDrawingMode(HPS) asm ("GpiQueryDrawingMode");
ULONG GpiQueryPS(HPS, PSIZEL) asm ("GpiQueryPS");
LONG GpiQueryStopDraw(HPS) asm ("GpiQueryStopDraw");
BOOL GpiResetPS(HPS, ULONG) asm ("GpiResetPS");
BOOL GpiSetDrawControl(HPS, LONG, LONG) asm ("GpiSetDrawControl");
BOOL GpiSetDrawingMode(HPS, LONG) asm ("GpiSetDrawingMode");
BOOL GpiSetPS(HPS, PSIZEL, ULONG) asm ("GpiSetPS");
BOOL GpiSetStopDraw(HPS, LONG) asm ("GpiSetStopDraw");

#endif


#ifdef INCL_GPICORRELATION

#define GPI_HITS					2L

#define PICKAP_DEFAULT					0L
#define PICKAP_REC					2L

#define PICKSEL_VISIBLE					0L
#define PICKSEL_ALL					1L

LONG GpiCorrelateChain(HPS, LONG, PPOINTL, LONG, LONG, PLONG) asm ("GpiCorrelateChain");
LONG GpiCorrelateFrom(HPS, LONG, LONG, LONG, PPOINTL, LONG, LONG, PLONG) asm ("GpiCorrelateFrom");
LONG GpiCorrelateSegment(HPS, LONG, LONG, PPOINTL, LONG, LONG, PLONG) asm ("GpiCorrelateSegment");
BOOL GpiQueryBoundaryData(HPS, PRECTL) asm ("GpiQueryBoundryData");
BOOL GpiQueryPickAperturePosition(HPS, PPOINTL) asm ("GpiQueryPickAperturePosition");
BOOL GpiQueryPickApertureSize(HPS, PSIZEL) asm ("GpiQueryPickApertureSize");
BOOL GpiQueryTag(HPS, PLONG) asm ("GpiQueryTag");
BOOL GpiResetBoundaryData(HPS) asm ("GpiResetBoundryData");
BOOL GpiSetPickAperturePosition(HPS, PPOINTL) asm ("GpiSetPickAperturePosition");
BOOL GpiSetPickApertureSize(HPS, LONG, PSIZEL) asm ("GpiSetPickApertureSize");
BOOL GpiSetTag(HPS, LONG) asm ("GpiSetTag");

#endif


#ifdef INCL_GPISEGMENTS

#define ATTR_ERROR					(-1L)
#define ATTR_DETECTABLE					1L
#define ATTR_VISIBLE					2L
#define ATTR_CHAINED					6L
#define ATTR_DYNAMIC					8L
#define ATTR_FASTCHAIN					9L
#define ATTR_PROP_DETECTABLE				10L
#define ATTR_PROP_VISIBLE				11L
#define ATTR_OFF					0L
#define ATTR_ON						1L

#define DFORM_NOCONV					0L
#define DFORM_S370SHORT					1L
#define DFORM_PCSHORT					2L
#define DFORM_PCLONG					4L

#define HIGHER_PRI					1L
#define LOWER_PRI					(-1L)

BOOL GpiCloseSegment(HPS) asm ("GpiCloseSegment");
BOOL GpiDeleteSegment(HPS, LONG) asm ("GpiDeleteSegment");
BOOL GpiDeleteSegments(HPS, LONG, LONG) asm ("GpiDeleteSegments");
BOOL GpiDrawChain(HPS) asm ("GpiDrawChain");
BOOL GpiDrawDynamics(HPS) asm ("GpiDrawDynamics");
BOOL GpiDrawFrom(HPS, LONG, LONG) asm ("GpiDrawFrom");
BOOL GpiDrawSegment(HPS, LONG) asm ("GpiDrawSegment");
LONG GpiGetData(HPS, LONG, PLONG, LONG, LONG, PBYTE) asm ("GpiGetData");
BOOL GpiOpenSegment(HPS, LONG) asm ("GpiOpenSegment");
LONG GpiQueryInitialSegmentAttrs(HPS, LONG) asm ("GpiQueryInitialSegmentAttrs");
LONG GpiQuerySegmentAttrs(HPS, LONG, LONG) asm ("GpiQuerySegmentAttrs");
LONG GpiQuerySegmentNames(HPS, LONG, LONG, LONG, PLONG) asm ("GpiQuerySegmentNames");
LONG GpiQuerySegmentPriority(HPS, LONG, LONG) asm ("GpiQuerySegmentPriority");
BOOL GpiRemoveDynamics(HPS, LONG, LONG) asm ("GpiRemoveDynamics");
BOOL GpiSetInitialSegmentAttrs(HPS, LONG, LONG) asm ("GpiSetInitialSegmentAttrs");
BOOL GpiSetSegmentAttrs(HPS, LONG, LONG, LONG) asm ("GpiSetSegmentAttrs");
BOOL GpiSetSegmentPriority(HPS, LONG, LONG, LONG) asm ("GpiSetSegmentPriority");

#endif


#ifdef INCL_GPISEGEDITING

#define SEGEM_ERROR					0L
#define SEGEM_INSERT					1L
#define SEGEM_REPLACE					2L

BOOL GpiBeginElement(HPS, LONG, PSZ) asm ("GpiBeginElement");
BOOL GpiDeleteElement(HPS) asm ("GpiDeleteElement");
BOOL GpiDeleteElementsBetweenLabels(HPS, LONG, LONG) asm ("GpiDeleteElementBetweenLabels");
BOOL GpiDeleteElementRange(HPS, LONG, LONG) asm ("GpiDeleteElementRange");
LONG GpiElement(HPS, LONG, PSZ, LONG, PBYTE) asm ("GpiElement");
BOOL GpiEndElement(HPS) asm ("GpiEndElement");
BOOL GpiLabel(HPS, LONG) asm ("GpiLabal");
BOOL GpiOffsetElementPointer(HPS, LONG) asm ("GpiOffsetElementPointer");
LONG GpiQueryEditMode(HPS) asm ("GpiQueryEditMode");
LONG GpiQueryElement(HPS, LONG, LONG, PBYTE) asm ("GpiQueryElement");
LONG GpiQueryElementPointer(HPS) asm ("GpiQueryElementPointer");
LONG GpiQueryElementType(HPS, PLONG, LONG, PSZ) asm ("GpiQueryElementType");
BOOL GpiSetEditMode(HPS, LONG) asm ("GpiSetEditMode");
BOOL GpiSetElementPointer(HPS, LONG) asm ("GpiSetElementPointer");
BOOL GpiSetElementPointerAtLabel(HPS, LONG) asm ("GpiSetElementPointerAtLabel");

#endif


#ifdef INCL_GPITRANSFORMS

#define CVTC_WORLD					1L
#define CVTC_MODEL					2L
#define CVTC_DEFAULTPAGE				3L
#define CVTC_PAGE					4L
#define CVTC_DEVICE					5L

#define TRANSFORM_REPLACE				0L
#define TRANSFORM_ADD					1L
#define TRANSFORM_PREEMPT				2L

#pragma pack(2)

typedef struct _MATRIXLF {
	FIXED fxM11;
	FIXED fxM12;
	LONG lM13;
	FIXED fxM21;
	FIXED fxM22;
	LONG lM23;
	LONG lM31;
	LONG lM32;
	LONG lM33;
} MATRIXLF, *PMATRIXLF;

#pragma pack(4)

LONG GpiCallSegmentMatrix(HPS, LONG, LONG, PMATRIXLF, LONG) asm ("GpiCallSegmentMatrix");
BOOL GpiConvert(HPS, LONG, LONG, LONG, PPOINTL) asm ("GpiConvert");
BOOL GpiConvertWithMatrix(HPS, LONG, PPOINTL, LONG, PMATRIXLF) asm ("GpiConvertWithMatrix");
BOOL GpiQueryDefaultViewMatrix(HPS, LONG, PMATRIXLF) asm ("GpiQueryDefaultViewMatrix");
BOOL GpiQueryGraphicsField(HPS, PRECTL) asm ("GpiQueryGraphicsField");
BOOL GpiQueryModelTransformMatrix(HPS, LONG, PMATRIXLF) asm ("GpiQueryModelTransformMatrix");
BOOL GpiQueryPageViewport(HPS, PRECTL) asm ("GpiQueryPageViewport");
BOOL GpiQuerySegmentTransformMatrix(HPS, LONG, LONG, PMATRIXLF) asm ("GpiQuerySegmentTransformMatrix");
BOOL GpiQueryViewingLimits(HPS, PRECTL) asm ("GpiQueryViewingLimits");
BOOL GpiQueryViewingTransformMatrix(HPS, LONG, PMATRIXLF) asm ("GpiQueryViewingTransformMatrix");
BOOL GpiRotate(HPS, PMATRIXLF, LONG, FIXED, PPOINTL) asm ("GpiRotate");
BOOL GpiScale(HPS, PMATRIXLF, LONG, PFIXED, PPOINTL) asm ("GpiScale");
BOOL GpiSetDefaultViewMatrix(HPS, LONG, PMATRIXLF, LONG) asm ("GpiSetDefaultViewMatrix");
BOOL GpiSetGraphicsField(HPS, PRECTL) asm ("GpiSetGraphicsField");
BOOL GpiSetModelTransformMatrix(HPS, LONG, PMATRIXLF, LONG) asm ("GpiSetModelTransformMatrix");
BOOL GpiSetPageViewport(HPS, PRECTL) asm ("GpiSetPageViewport");
BOOL GpiSetSegmentTransformMatrix(HPS, LONG, LONG, PMATRIXLF, LONG) asm ("GpiSetSegmentTransformMatrix");
BOOL GpiSetViewingLimits(HPS, PRECTL) asm ("GpiSetViewingLimits");
BOOL GpiSetViewingTransformMatrix(HPS, LONG, PMATRIXLF, LONG) asm ("GpiSetViewingTransformMatrix");
BOOL GpiTranslate(HPS, PMATRIXLF, LONG, PPOINTL) asm ("GpiTranslate");

#endif


#ifdef INCL_GPIPATHS

#define FPATH_ALTERNATE					0L
#define FPATH_WINDING					2L

#define MPATH_STROKE					6L

#define SCP_ALTERNATE					0L
#define SCP_WINDING					2L
#define SCP_AND						4L
#define SCP_RESET					0L

BOOL GpiBeginPath(HPS, LONG) asm ("GpiBeginPath");
BOOL GpiCloseFigure(HPS) asm ("GpiCloseFigure");
BOOL GpiEndPath(HPS) asm ("GpiEndPath");
LONG GpiFillPath(HPS, LONG, LONG) asm ("GpiFillPath");
BOOL GpiModifyPath(HPS, LONG, LONG) asm ("GpiModifyPath");
LONG GpiOutlinePath(HPS, LONG, LONG) asm ("GpiOutlinePath");
HRGN GpiPathToRegion(HPS, LONG, LONG) asm ("GpiPathToRegion");
BOOL GpiSetClipPath(HPS, LONG, LONG) asm ("GpiSetClipPath");
LONG GpiStrokePath(HPS, LONG, ULONG) asm ("GpiStrokePath");

#endif


#ifdef INCL_GPILOGCOLORTABLE

#ifndef INCL_GPIBITMAPS
#define INCL_GPIBITMAPS
#endif

#define LCOL_RESET					0x0001L
#define LCOL_REALIZABLE					0x0002L
#define LCOL_PURECOLOR					0x0004L
#define LCOL_OVERRIDE_DEFAULT_COLORS			0x0008L
#define LCOL_REALIZED					0x0010L

#define LCOLF_DEFAULT					0L
#define LCOLF_INDRGB					1L
#define LCOLF_CONSECRGB					2L
#define LCOLF_RGB					3L
#define LCOLF_PALETTE					4L

#define LCOLOPT_REALIZED				0x0001L
#define LCOLOPT_INDEX					0x0002L

#define PAL_ERROR					(-1L)

#define PC_RESERVED					0x01
#define PC_EXPLICIT					0x02
#define PC_NOCOLLAPSE					0x04

#define QLCT_ERROR					(-1L)
#define QLCT_RGB					(-2L)
#define QLCT_NOTLOADED					(-1L)
#define QCD_LCT_FORMAT					0L
#define QCD_LCT_LOINDEX					1L
#define QCD_LCT_HIINDEX					2L
#define QCD_LCT_OPTIONS					3L


LONG GpiAnimatePalette(HPAL, ULONG, ULONG, ULONG, PULONG) asm ("GpiAnimatePalette");
BOOL GpiCreateLogColorTable(HPS, ULONG, LONG, LONG, LONG, PLONG) asm ("GpiCreateLogColorTable");
HPAL GpiCreatePalette(HAB, ULONG, ULONG, ULONG, PULONG) asm ("GpiCreatePalette");
BOOL GpiDeletePalette(HPAL) asm ("GpiDeletePalette");
BOOL GpiQueryColorData(HPS, LONG, PLONG) asm ("GpiQueryColorData");
LONG GpiQueryColorIndex(HPS, ULONG, LONG) asm ("GpiQueryColorIndex");
LONG GpiQueryDefaultPaletteInfo(HPS, ULONG, ULONG, ULONG, PULONG) asm ("GpiQueryDefaultPaletteInfo");
LONG GpiQueryLogColorTable(HPS, ULONG, LONG, LONG, PLONG) asm ("GpiQueryLogColorTable");
LONG GpiQueryNearestColor(HPS, ULONG, LONG) asm ("GpiQueryNearestColor");
HPAL GpiQueryPalette(HPS) asm ("GpiQueryPalette");
LONG GpiQueryPaletteInfo(HPAL, ULONG, ULONG, ULONG, PULONG) asm ("GpiQueryPaletteInfo");
LONG GpiQueryRealColors(HPS, ULONG, LONG, LONG, PLONG) asm ("GpiQueryRealColors");
LONG GpiQueryRGBColor(HPS, ULONG, LONG) asm ("GpiQueryRGBColor");
BOOL GpiRealizeColorTable(HPS) asm ("GpiRealizeColorTable");
BOOL GpiResizePalette(HPAL, ULONG) asm ("GpiResizePalette");
HPAL GpiSelectPalette(HPS, HPAL) asm ("GpiSelectPalette");
BOOL GpiSetPaletteEntries(HPAL, ULONG, ULONG, ULONG, PULONG) asm ("GpiSetPaletteEntries");
BOOL GpiUnrealizeColorTable(HPS) asm ("GpiUnrealizeColorTable");
BOOL GpiUpdateColors (HPS) asm ("GpiUpdateColors");

#endif


#if (defined(INCL_GPIPRIMITIVES) || !defined(INCL_NOCOMMON))

#define BA_NOBOUNDARY					0L
#define BA_BOUNDARY					0x0001L
#define BA_ALTERNATE					0L
#define BA_WINDING					0x0002L

#define CLR_FALSE					(-5L)
#define CLR_TRUE					(-4L)
#define CLR_ERROR					(-255L)
#define CLR_DEFAULT					(-3L)
#define CLR_WHITE					(-2L)
#define CLR_BLACK					(-1L)
#define CLR_BACKGROUND					0L
#define CLR_BLUE					1L
#define CLR_RED						2L
#define CLR_PINK					3L
#define CLR_GREEN					4L
#define CLR_CYAN					5L
#define CLR_YELLOW					6L
#define CLR_NEUTRAL					7L
#define CLR_DARKGRAY					8L
#define CLR_DARKBLUE					9L
#define CLR_DARKRED					10L
#define CLR_DARKPINK					11L
#define CLR_DARKGREEN					12L
#define CLR_DARKCYAN					13L
#define CLR_BROWN					14L
#define CLR_PALEGRAY					15L

#define DRO_FILL					1L
#define DRO_OUTLINE					2L
#define DRO_OUTLINEFILL					3L

#define LCID_ERROR					(-1L)
#define LCID_DEFAULT					0L

#define PATSYM_ERROR					(-1L)
#define PATSYM_DEFAULT					0L
#define PATSYM_DENSE1					1L
#define PATSYM_DENSE2					2L
#define PATSYM_DENSE3					3L
#define PATSYM_DENSE4					4L
#define PATSYM_DENSE5					5L
#define PATSYM_DENSE6					6L
#define PATSYM_DENSE7					7L
#define PATSYM_DENSE8					8L
#define PATSYM_VERT					9L
#define PATSYM_HORIZ					10L
#define PATSYM_DIAG1					11L
#define PATSYM_DIAG2					12L
#define PATSYM_DIAG3					13L
#define PATSYM_DIAG4					14L
#define PATSYM_NOSHADE					15L
#define PATSYM_SOLID					16L
#define PATSYM_HALFTONE					17L
#define PATSYM_HATCH					18L
#define PATSYM_DIAGHATCH				19L
#define PATSYM_BLANK					64L

#define RGB_ERROR					(-255L)
#define RGB_BLACK					0x00000000L
#define RGB_BLUE					0x000000FFL
#define RGB_GREEN					0x0000FF00L
#define RGB_CYAN					0x0000FFFFL
#define RGB_RED						0x00FF0000L
#define RGB_PINK					0x00FF00FFL
#define RGB_YELLOW					0x00FFFF00L
#define RGB_WHITE					0x00FFFFFFL


BOOL GpiSetColor(HPS, LONG) asm ("GpiSetColor");
LONG GpiQueryColor(HPS) asm ("GpiQueryColor");
LONG GpiBox(HPS, LONG, PPOINTL, LONG, LONG) asm ("GpiBox");
BOOL GpiMove(HPS, PPOINTL) asm ("GpiMove");
LONG GpiLine(HPS, PPOINTL) asm ("GpiLine");
LONG GpiPolyLine(HPS, LONG, PPOINTL) asm ("GpiPolyLine");
BOOL GpiSetPattern(HPS, LONG) asm ("GpiSetPattern");
LONG GpiQueryPattern(HPS) asm ("GpiQueryPattern");
BOOL GpiBeginArea(HPS, ULONG) asm ("GpiBeginArea");
LONG GpiEndArea(HPS) asm ("GpiEndArea");
LONG GpiCharString(HPS, LONG, PCH) asm ("GpiCharString");
LONG GpiCharStringAt(HPS, PPOINTL, LONG, PCH) asm ("GpiCharStringAt");

#endif


#ifdef INCL_GPIPRIMITIVES

#define ABB_COLOR					0x0001L
#define ABB_BACK_COLOR					0x0002L
#define ABB_MIX_MODE					0x0004L
#define ABB_BACK_MIX_MODE				0x0008L
#define ABB_SET						0x0010L
#define ABB_SYMBOL					0x0020L
#define ABB_REF_POINT					0x0040L

#define AM_ERROR					(-1L)
#define AM_PRESERVE					0L
#define AM_NOPRESERVE					1L

#define BM_ERROR					(-1L)
#define BM_DEFAULT					0L
#define BM_OR						1L
#define BM_OVERPAINT					2L
#define BM_XOR						4L
#define BM_LEAVEALONE					5L
#define BM_AND						6L
#define BM_SUBTRACT					7L
#define BM_MASKSRCNOT					8L
#define BM_ZERO						9L
#define BM_NOTMERGESRC					10L
#define BM_NOTXORSRC					11L
#define BM_INVERT					12L
#define BM_MERGESRCNOT					13L
#define BM_NOTCOPYSRC					14L
#define BM_MERGENOTSRC					15L
#define BM_NOTMASKSRC					16L
#define BM_ONE						17L

#define CBB_COLOR					0x0001L
#define CBB_BACK_COLOR					0x0002L
#define CBB_MIX_MODE					0x0004L
#define CBB_BACK_MIX_MODE				0x0008L
#define CBB_SET						0x0010L
#define CBB_MODE					0x0020L
#define CBB_BOX						0x0040L
#define CBB_ANGLE					0x0080L
#define CBB_SHEAR					0x0100L
#define CBB_DIRECTION					0x0200L
#define CBB_RESERVED					0x0400L
#define CBB_EXTRA					0x0800L
#define CBB_BREAK_EXTRA					0x1000L

#define CHDIRN_ERROR					(-1L)
#define CHDIRN_DEFAULT					0L
#define CHDIRN_LEFTRIGHT				1L
#define CHDIRN_TOPBOTTOM				2L
#define CHDIRN_RIGHTLEFT				3L
#define CHDIRN_BOTTOMTOP				4L

#define CHS_OPAQUE					0x0001L
#define CHS_VECTOR					0x0002L
#define CHS_LEAVEPOS					0x0008L
#define CHS_CLIP					0x0010L
#define CHS_UNDERSCORE					0x0200L
#define CHS_STRIKEOUT					0x0400L

#define CM_ERROR					(-1L)
#define CM_DEFAULT					0L
#define CM_MODE1					1L
#define CM_MODE2					2L
#define CM_MODE3					3L

#define FM_ERROR					(-1L)
#define FM_DEFAULT					0L
#define FM_OR						1L
#define FM_OVERPAINT					2L
#define FM_XOR						4L
#define FM_LEAVEALONE					5L
#define FM_AND						6L
#define FM_SUBTRACT					7L
#define FM_MASKSRCNOT					8L
#define FM_ZERO						9L
#define FM_NOTMERGESRC					10L
#define FM_NOTXORSRC					11L
#define FM_INVERT					12L
#define FM_MERGESRCNOT					13L
#define FM_NOTCOPYSRC					14L
#define FM_MERGENOTSRC					15L
#define FM_NOTMASKSRC					16L
#define FM_ONE						17L

#define IBB_COLOR					0x0001L
#define IBB_BACK_COLOR					0x0002L
#define IBB_MIX_MODE					0x0004L
#define IBB_BACK_MIX_MODE				0x0008L

#define LBB_COLOR					0x0001L
#define LBB_BACK_COLOR					0x0002L
#define LBB_MIX_MODE					0x0004L
#define LBB_BACK_MIX_MODE				0x0008L
#define LBB_WIDTH					0x0010L
#define LBB_GEOM_WIDTH					0x0020L
#define LBB_TYPE					0x0040L
#define LBB_END						0x0080L
#define LBB_JOIN					0x0100L

#define LINEEND_ERROR					(-1L)
#define LINEEND_DEFAULT					0L
#define LINEEND_FLAT					1L
#define LINEEND_SQUARE					2L
#define LINEEND_ROUND					3L

#define LINEJOIN_ERROR					(-1L)
#define LINEJOIN_DEFAULT				0L
#define LINEJOIN_BEVEL					1L
#define LINEJOIN_ROUND					2L
#define LINEJOIN_MITRE					3L

#define LINETYPE_ERROR					(-1L)
#define LINETYPE_DEFAULT				0L
#define LINETYPE_DOT					1L
#define LINETYPE_SHORTDASH				2L
#define LINETYPE_DASHDOT				3L
#define LINETYPE_DOUBLEDOT				4L
#define LINETYPE_LONGDASH				5L
#define LINETYPE_DASHDOUBLEDOT				6L
#define LINETYPE_SOLID					7L
#define LINETYPE_INVISIBLE				8L
#define LINETYPE_ALTERNATE				9L

#define LINEWIDTH_ERROR					(-1L)
#define LINEWIDTH_DEFAULT				0L
#define LINEWIDTH_NORMAL				0x00010000L
#define LINEWIDTH_THICK					0x00020000L

#define LINEWIDTHGEOM_ERROR				(-1L)

#define MARKSYM_ERROR					(-1L)
#define MARKSYM_DEFAULT					0L
#define MARKSYM_CROSS					1L
#define MARKSYM_PLUS					2L
#define MARKSYM_DIAMOND					3L
#define MARKSYM_SQUARE					4L
#define MARKSYM_SIXPOINTSTAR				5L
#define MARKSYM_EIGHTPOINTSTAR				6L
#define MARKSYM_SOLIDDIAMOND				7L
#define MARKSYM_SOLIDSQUARE				8L
#define MARKSYM_DOT					9L
#define MARKSYM_SMALLCIRCLE				10L
#define MARKSYM_BLANK					64L

#define MBB_COLOR					0x0001L
#define MBB_BACK_COLOR					0x0002L
#define MBB_MIX_MODE					0x0004L
#define MBB_BACK_MIX_MODE				0x0008L
#define MBB_SET						0x0010L
#define MBB_SYMBOL					0x0020L
#define MBB_BOX						0x0040L

#define PRIM_LINE					1L
#define PRIM_CHAR					2L
#define PRIM_MARKER					3L
#define PRIM_AREA					4L
#define PRIM_IMAGE					5L

#define PVIS_ERROR					0L
#define PVIS_INVISIBLE					1L
#define PVIS_VISIBLE					2L

#define RVIS_ERROR					0L
#define RVIS_INVISIBLE					1L
#define RVIS_PARTIAL					2L
#define RVIS_VISIBLE					3L

#define TA_NORMAL_HORIZ					0x0001
#define TA_LEFT						0x0002
#define TA_CENTER					0x0003
#define TA_RIGHT					0x0004
#define TA_STANDARD_HORIZ				0x0005
#define TA_NORMAL_VERT					0x0100
#define TA_TOP						0x0200
#define TA_HALF						0x0300
#define TA_BASE						0x0400
#define TA_BOTTOM					0x0500
#define TA_STANDARD_VERT				0x0600

#define TXTBOX_TOPLEFT					0L
#define TXTBOX_BOTTOMLEFT				1L
#define TXTBOX_TOPRIGHT					2L
#define TXTBOX_BOTTOMRIGHT				3L
#define TXTBOX_CONCAT					4L
#define TXTBOX_COUNT					5L

#pragma pack(2)

typedef struct _ARCPARAMS {
	LONG lP;
	LONG lQ;
	LONG lR;
	LONG lS;
} ARCPARAMS, *PARCPARAMS;

typedef struct _AREABUNDLE {
	LONG lColor;
	LONG lBackColor;
	USHORT usMixMode;
	USHORT usBackMixMode;
	USHORT usSet;
	USHORT usSymbol;
	POINTL ptlRefPoint ;
} AREABUNDLE, *PAREABUNDLE;

typedef struct _SIZEF {
	FIXED cx;
	FIXED cy;
} SIZEF, *PSIZEF;

typedef struct _CHARBUNDLE {
	LONG lColor;
	LONG lBackColor;
	USHORT usMixMode;
	USHORT usBackMixMode;
	USHORT usSet;
	USHORT usPrecision;
	SIZEF sizfxCell;
	POINTL ptlAngle;
	POINTL ptlShear;
	USHORT usDirection;
	USHORT usReserved;
	FIXED fxExtra;
	FIXED fxBreakExtra;
} CHARBUNDLE, *PCHARBUNDLE;

typedef struct _GRADIENTL {
	LONG x;
	LONG y;
} GRADIENTL, *PGRADIENTL;

typedef struct _IMAGEBUNDLE {
	LONG lColor;
	LONG lBackColor;
	USHORT usMixMode;
	USHORT usBackMixMode;
} IMAGEBUNDLE, *PIMAGEBUNDLE;

typedef struct _LINEBUNDLE {
	LONG lColor;
	LONG lBackColor;
	USHORT usMixMode;
	USHORT usBackMixMode;
	FIXED fxWidth;
	LONG lGeomWidth;
	USHORT usType;
	USHORT usEnd;
	USHORT usJoin;
} LINEBUNDLE, *PLINEBUNDLE;

typedef struct _MARKERBUNDLE {
	LONG lColor;
	LONG lBackColor;
	USHORT usMixMode;
	USHORT usBackMixMode;
	USHORT usSet;
	USHORT usSymbol;
	SIZEF sizfxCell;
} MARKERBUNDLE, *PMARKERBUNDLE;

typedef PVOID PBUNDLE;

#pragma pack(4)


LONG GpiCharStringPos(HPS, PRECTL, ULONG, LONG, PCH, PLONG) asm ("GpiCharStringPos");
LONG GpiCharStringPosAt(HPS, PPOINTL, PRECTL, ULONG, LONG, PCH, PLONG) asm ("GpiCharStringPosAt");
BOOL GpiComment(HPS, LONG, PBYTE) asm ("GpiComment");
LONG GpiFullArc(HPS, LONG, FIXED) asm ("GpiFullArc");
LONG GpiImage(HPS, LONG, PSIZEL, LONG, PBYTE) asm ("GpiImage");
LONG GpiMarker(HPS, PPOINTL) asm ("GpiMarker");
LONG GpiPartialArc(HPS, PPOINTL, FIXED, FIXED, FIXED) asm ("GpiPartialArc");
LONG GpiPointArc(HPS, PPOINTL) asm ("GpiPointArc");
LONG GpiPolyFillet(HPS, LONG, PPOINTL) asm ("GpiPolyFillet");
LONG GpiPolyFilletSharp(HPS, LONG, PPOINTL, PFIXED) asm ("GpiPolyFilletSharp");
LONG GpiPolyMarker(HPS, LONG, PPOINTL) asm ("GpiPolyMarker");
LONG GpiPolySpline(HPS, LONG, PPOINTL) asm ("GpiPolySpline");
BOOL GpiPop(HPS, LONG) asm ("GpiPop");
LONG GpiPtVisible(HPS, PPOINTL) asm ("GpiPtVisible");
BOOL GpiQueryArcParams(HPS, PARCPARAMS) asm ("GpiQueryArcParams");
LONG GpiQueryAttrMode(HPS) asm ("GpiQueryAttrMode");
LONG GpiQueryAttrs(HPS, LONG, ULONG, PBUNDLE) asm ("GpiQueryAttrs");
LONG GpiQueryBackColor(HPS) asm ("GpiQueryBackColor");
LONG GpiQueryBackMix(HPS) asm ("GpiQueryBackMix");
BOOL GpiQueryCharAngle(HPS, PGRADIENTL) asm ("GpiQueryCharAngle");
BOOL GpiQueryCharBox(HPS, PSIZEF) asm ("GpiQueryCharBox");
BOOL GpiQueryCharBreakExtra(HPS, PFIXED) asm ("GpiQueryCharBreakExtra");
LONG GpiQueryCharDirection(HPS) asm ("GpiQueryCharDirection");
BOOL GpiQueryCharExtra(HPS, PFIXED) asm ("GpiQueryCharExtra");
LONG GpiQueryCharMode(HPS) asm ("GpiQueryCharMode");
LONG GpiQueryCharSet(HPS) asm ("GpiQueryCharSet");
BOOL GpiQueryCharShear(HPS, PPOINTL) asm ("GpiQueryCharShear");
BOOL GpiQueryCharStringPos(HPS, ULONG, LONG, PCH, PLONG, PPOINTL) asm ("GpiQueryCharStringPos");
BOOL GpiQueryCharStringPosAt(HPS, PPOINTL, ULONG, LONG, PCH, PLONG, PPOINTL) asm ("GpiQueryCharStringPosAt");
BOOL GpiQueryCurrentPosition(HPS, PPOINTL) asm ("GpiQueryCurrentPosition");
BOOL GpiQueryDefCharBox(HPS, PSIZEL) asm ("GpiQueryDefCharBox");
LONG GpiQueryLineEnd(HPS) asm ("GpiQueryLineEnd");
LONG GpiQueryLineJoin(HPS) asm ("GpiQueryLineJoin");
LONG GpiQueryLineType(HPS) asm ("GpiQueryLineType");
FIXED GpiQueryLineWidth(HPS) asm ("GpiQueryLineWidth");
LONG GpiQueryLineWidthGeom(HPS) asm ("GpiQueryLineWidthGeom");
LONG GpiQueryMarker(HPS) asm ("GpiQueryMarker");
BOOL GpiQueryMarkerBox(HPS, PSIZEF) asm ("GpiQueryMarkerBox");
LONG GpiQueryMarkerSet(HPS) asm ("GpiQueryMarkerSet");
LONG GpiQueryMix(HPS) asm ("GpiQueryMix");
BOOL GpiQueryPatternRefPoint(HPS, PPOINTL) asm ("GpiQueryPatternRefPoint");
LONG GpiQueryPatternSet(HPS) asm ("GpiQueryPatternSet");
BOOL GpiQueryTextBox(HPS, LONG, PCH, LONG, PPOINTL) asm ("GpiQueryTextBox");
LONG GpiRectVisible(HPS, PRECTL) asm ("GpiRectVisible");
BOOL GpiSetArcParams(HPS, PARCPARAMS) asm ("GpiSetArcParams");
BOOL GpiSetAttrMode(HPS, LONG) asm ("GpiSetAttrMode");
BOOL GpiSetAttrs(HPS, LONG, ULONG, ULONG, PBUNDLE) asm ("GpiSetAttrs");
BOOL GpiSetBackColor(HPS, LONG) asm ("GpiSetBackColor");
BOOL GpiSetBackMix(HPS, LONG) asm ("GpiSetBackMix");
BOOL GpiSetCharAngle(HPS, PGRADIENTL) asm ("GpiSetCharAngle");
BOOL GpiSetCharBox(HPS, PSIZEF) asm ("GpiSetCharBox");
BOOL GpiSetCharBreakExtra(HPS, FIXED) asm ("GpiSetCharBreakExtra");
BOOL GpiSetCharDirection(HPS, LONG) asm ("GpiSetCharDirection");
BOOL GpiSetCharExtra(HPS, FIXED) asm ("GpiSetCharExtra");
BOOL GpiSetCharMode(HPS, LONG) asm ("GpiSetCharMode");
BOOL GpiSetCharSet(HPS, LONG) asm ("GpiSetCharSet");
BOOL GpiSetCharShear(HPS, PPOINTL) asm ("GpiSetCharShear");
BOOL GpiSetCurrentPosition(HPS, PPOINTL) asm ("GpiSetCurrentPosition");
BOOL GpiSetLineEnd(HPS, LONG) asm ("GpiSetLineEnd");
BOOL GpiSetLineJoin(HPS, LONG) asm ("GpiSetLineJoin");
BOOL GpiSetLineType(HPS, LONG) asm ("GpiSetLineType");
BOOL GpiSetLineWidth(HPS, FIXED) asm ("GpiSetLineWidth");
BOOL GpiSetLineWidthGeom(HPS, LONG) asm ("GpiSetLineWidthGeom");
BOOL GpiSetMarker(HPS, LONG) asm ("GpiSetMarker");
BOOL GpiSetMarkerBox(HPS, PSIZEF) asm ("GpiSetMarkerBox");
BOOL GpiSetMarkerSet(HPS, LONG) asm ("GpiSetMarkerSet");
BOOL GpiSetMix(HPS, LONG) asm ("GpiSetMix");
BOOL GpiSetPatternRefPoint(HPS, PPOINTL) asm ("GpiSetPatternRefPoint");
BOOL GpiSetPatternSet(HPS, LONG) asm ("GpiSetPatternSet");

#endif


#ifdef INCL_GPILCIDS

#define FONT_DEFAULT					1L
#define FONT_MATCH					2L

#define FTYPE_ITALIC					0x0001
#define FTYPE_ITALIC_DONT_CARE				0x0002
#define FTYPE_OBLIQUE					0x0004
#define FTYPE_OBLIQUE_DONT_CARE				0x0008
#define FTYPE_ROUNDED					0x0010
#define FTYPE_ROUNDED_DONT_CARE				0x0020

#define FWEIGHT_DONT_CARE				0L
#define FWEIGHT_ULTRA_LIGHT				1L
#define FWEIGHT_EXTRA_LIGHT				2L
#define FWEIGHT_LIGHT					3L
#define FWEIGHT_SEMI_LIGHT				4L
#define FWEIGHT_NORMAL					5L
#define FWEIGHT_SEMI_BOLD				6L
#define FWEIGHT_BOLD					7L
#define FWEIGHT_EXTRA_BOLD				8L
#define FWEIGHT_ULTRA_BOLD				9L

#define FWIDTH_DONT_CARE				0L
#define FWIDTH_ULTRA_CONDENSED				1L
#define FWIDTH_EXTRA_CONDENSED				2L
#define FWIDTH_CONDENSED				3L
#define FWIDTH_SEMI_CONDENSED				4L
#define FWIDTH_NORMAL					5L
#define FWIDTH_SEMI_EXPANDED				6L
#define FWIDTH_EXPANDED					7L
#define FWIDTH_EXTRA_EXPANDED				8L
#define FWIDTH_ULTRA_EXPANDED				9L

#define LCID_ALL					(-1L)
#define LCIDT_FONT					6L
#define LCIDT_BITMAP					7L

#define QF_PUBLIC					0x0001L
#define QF_PRIVATE					0x0002L
#define QF_NO_GENERIC					0x0004L
#define QF_NO_DEVICE					0x0008L

#define QFA_PUBLIC					1L
#define QFA_PRIVATE					2L
#define QFA_ERROR					GPI_ALTERROR

#pragma pack(2)

typedef struct _FACENAMEDESC {
	USHORT usSize;
	USHORT usWeightClass;
	USHORT usWidthClass;
	USHORT usReserved;
	ULONG flOptions;
} FACENAMEDESC, *PFACENAMEDESC;

typedef struct _KERNINGPAIRS {
	SHORT sFirstChar;
	SHORT sSecondChar;
	LONG lKerningAmount;
} KERNINGPAIRS, *PKERNINGPAIRS;

#pragma pack(4)

typedef CHAR FFDESCS[2][FACESIZE];
typedef FFDESCS *PFFDESCS;

LONG GpiCreateLogFont(HPS, PSTR8, LONG, PFATTRS) asm ("GpiCreateLogFont");
BOOL GpiDeleteSetId(HPS, LONG) asm ("GpiDeleteSetId");
BOOL GpiLoadFonts(HAB, PSZ) asm ("GpiLoadFonts");
BOOL GpiLoadPublicFonts(HAB, PSZ) asm ("GpiLoadPublicFonts");
USHORT GpiQueryCp(HPS) asm ("GpiQueryCp");
ULONG GpiQueryFaceString(HPS, PSZ, PFACENAMEDESC, LONG, PSZ) asm ("GpiQueryFaceString");
ULONG GpiQueryFontAction(HAB, ULONG) asm ("GpiQueryFontAction");
LONG GpiQueryFontFileDescriptions(HAB, PSZ, PLONG, PFFDESCS) asm ("GpiQueryFontFileDescriptions");
BOOL GpiQueryFontMetrics(HPS, LONG, PFONTMETRICS) asm ("GpiQueryFontMetrics");
LONG GpiQueryFonts(HPS, ULONG, PSZ, PLONG, LONG, PFONTMETRICS) asm ("GpiQueryFonts");
LONG GpiQueryKerningPairs(HPS, LONG, PKERNINGPAIRS) asm ("GpiQueryKerningPairs");
BOOL GpiQueryLogicalFont(HPS, LONG, PSTR8, PFATTRS, LONG) asm ("GpiQueryLogicalFont");
LONG GpiQueryNumberSetIds(HPS) asm ("GpiQueryNumberSetIds");
BOOL GpiQuerySetIds(HPS, LONG, PLONG, PSTR8, PLONG) asm ("GpiQuerySetIds");
BOOL GpiQueryWidthTable(HPS, LONG, LONG, PLONG) asm ("GpiQueryWidthTable");
BOOL GpiSetCp(HPS, USHORT) asm ("GpiSetCp");
BOOL GpiUnloadFonts(HAB, PSZ) asm ("GpiUnloadFonts");
BOOL GpiUnloadPublicFonts(HAB, PSZ) asm ("GpiUnloadPublicFonts");

#endif


#if (defined(INCL_GPIBITMAPS) || !defined(INCL_NOCOMMON))
#include <pmbitmap.h>
#endif

#ifdef INCL_GPIBITMAPS

LONG GpiBitBlt(HPS, HPS, LONG, PPOINTL, LONG, ULONG) asm ("GpiBitBlt");
HBITMAP GpiCreateBitmap(HPS, PBITMAPINFOHEADER2, ULONG, PBYTE, PBITMAPINFO2) asm ("GpiCreateBitmap");
BOOL GpiDeleteBitmap(HBITMAP) asm ("GpiDeleteBitmap");
LONG GpiDrawBits(HPS, PVOID, PBITMAPINFO2, LONG, PPOINTL, LONG, ULONG) asm ("GpiDrawBits");
LONG GpiFloodFill(HPS, LONG, LONG) asm ("GpiFlodFill");
HBITMAP GpiLoadBitmap(HPS, HMODULE, USHORT, LONG, LONG) asm ("GpiLoadBitmap");
LONG GpiQueryBitmapBits(HPS, LONG, LONG, PBYTE, PBITMAPINFO2) asm ("GpiQueryBitmapBits");
BOOL GpiQueryBitmapDimension(HBITMAP, PSIZEL) asm ("GpiQueryBitmapDimension");
HBITMAP GpiQueryBitmapHandle(HPS, LONG) asm ("GpiQueryBitmapHandle");
BOOL GpiQueryBitmapInfoHeader(HBITMAP, PBITMAPINFOHEADER2) asm ("GpiQueryBitmapInfoHeader");
BOOL GpiQueryBitmapParameters(HBITMAP, PBITMAPINFOHEADER) asm ("GpiQueryBitmapParameters");
BOOL GpiQueryDeviceBitmapFormats(HPS, LONG, PLONG) asm ("GpiQueryDeviceBitmapFormats");
LONG GpiQueryPel(HPS, PPOINTL) asm ("GpiQueryPel");
HBITMAP GpiSetBitmap(HPS, HBITMAP) asm ("GpiSetBitmap");
LONG GpiSetBitmapBits(HPS, LONG, LONG, PBYTE, PBITMAPINFO2) asm ("GpiSetBitmapBits");
BOOL GpiSetBitmapDimension(HBITMAP, PSIZEL) asm ("GpiSetBitmapDimension");
BOOL GpiSetBitmapId(HPS, HBITMAP, LONG) asm ("GpiSetBitmapId");
LONG GpiSetPel(HPS, PPOINTL) asm ("GpiSetPel");
LONG GpiWCBitBlt(HPS, HBITMAP, LONG, PPOINTL, LONG, ULONG) asm ("GpiWCBitBlt");

#endif

#ifdef INCL_GPIREGIONS

#define CRGN_OR						1L
#define CRGN_COPY					2L
#define CRGN_XOR					4L
#define CRGN_AND					6L
#define CRGN_DIFF					7L

#define EQRGN_ERROR					0L
#define EQRGN_NOTEQUAL					1L
#define EQRGN_EQUAL					2L

#define HRGN_ERROR					((HRGN)-1L)

#define PRGN_ERROR					0L
#define PRGN_OUTSIDE					1L
#define PRGN_INSIDE					2L

#define RECTDIR_LFRT_TOPBOT				1L
#define RECTDIR_RTLF_TOPBOT				2L
#define RECTDIR_LFRT_BOTTOP				3L
#define RECTDIR_RTLF_BOTTOP				4L

#define RGN_ERROR					0L
#define RGN_NULL					1L
#define RGN_RECT					2L
#define RGN_COMPLEX					3L

#define RRGN_ERROR					0L
#define RRGN_OUTSIDE					1L
#define RRGN_PARTIAL					2L
#define RRGN_INSIDE					3L

#pragma pack(2)

typedef struct _RGNRECT {
	ULONG ircStart;
	ULONG crc;
	ULONG crcReturned;
	USHORT usDirection;
} RGNRECT, *PRGNRECT;

#pragma pack(4)

LONG GpiCombineRegion(HPS, HRGN, HRGN, HRGN, LONG) asm ("GpiCombineRegion");
HRGN GpiCreateRegion(HPS, LONG, PRECTL) asm ("GpiCreateRegion");
BOOL GpiDestroyRegion(HPS, HRGN) asm ("GpiDestroyRegion");
LONG GpiEqualRegion(HPS, HRGN, HRGN) asm ("GpiEqualRegion");
LONG GpiExcludeClipRectangle(HPS, PRECTL) asm ("GpiExcludeClipRectangle");
LONG GpiFrameRegion(HPS, HRGN, PSIZEL) asm ("GpiFrameRegion");
LONG GpiIntersectClipRectangle(HPS, PRECTL) asm ("GpiIntersectClipRectangle");
LONG GpiOffsetClipRegion(HPS, PPOINTL) asm ("GpiOffsetClipRegion");
BOOL GpiOffsetRegion(HPS, HRGN, PPOINTL) asm ("GpiOffsetRegion");
LONG GpiPaintRegion(HPS, HRGN) asm ("GpiPaintRegion");
LONG GpiPtInRegion(HPS, HRGN, PPOINTL) asm ("GpiPtInRegion");
LONG GpiQueryClipBox(HPS, PRECTL) asm ("GpiQueryClipBox");
HRGN GpiQueryClipRegion(HPS) asm ("GpiQueryClipRegion");
LONG GpiQueryRegionBox(HPS, HRGN, PRECTL) asm ("GpiQueryRegionBox");
BOOL GpiQueryRegionRects(HPS, HRGN, PRECTL, PRGNRECT, PRECTL) asm ("GpiQueryRegionRects");
LONG GpiRectInRegion(HPS, HRGN, PRECTL) asm ("GpiRectInRegion");
LONG GpiSetClipRegion(HPS, HRGN, PHRGN) asm ("GpiSetClipRegion");
BOOL GpiSetRegion(HPS, HRGN, LONG, PRECTL) asm ("GpiSetRegion");

#endif

#ifdef INCL_GPIMETAFILES

#define CREA_DEFAULT					0L
#define CREA_REALIZE					1L
#define CREA_NOREALIZE					2L
#define CREA_DOREALIZE					3L

#define CTAB_DEFAULT					0L
#define CTAB_NOMODIFY					1L
#define CTAB_REPLACE					3L
#define CTAB_REPLACEPALETTE				4L

#define DDEF_DEFAULT					0L
#define DDEF_IGNORE					1L
#define DDEF_LOADDISC					3L

#define DOBJ_DEFAULT					0L
#define DOBJ_NODELETE					1L
#define DOBJ_DELETE					2L

#define LC_DEFAULT					0L
#define LC_NOLOAD					1L
#define LC_LOADDISC					3L

#define LT_DEFAULT					0L
#define LT_NOMODIFY					1L
#define LT_ORIGINALVIEW					4L

#define PMF_SEGBASE					0
#define PMF_LOADTYPE					1
#define PMF_RESOLVE					2
#define PMF_LCIDS					3
#define PMF_RESET					4
#define PMF_SUPPRESS					5
#define PMF_COLORTABLES					6
#define PMF_COLORREALIZABLE				7
#define PMF_DEFAULTS					8
#define PMF_DELETEOBJECTS				9

#define RES_DEFAULT					0L
#define RES_NORESET					1L
#define RES_RESET					2L

#define RS_DEFAULT					0L
#define RS_NODISCARD					1L

#define RSP_DEFAULT					0L
#define RSP_NODISCARD					1L

#define SUP_DEFAULT					0L
#define SUP_NOSUPPRESS					1L
#define SUP_SUPPRESS					2L

HMF GpiCopyMetaFile(HMF) asm ("GpiCopyMetaFile");
BOOL GpiDeleteMetaFile(HMF) asm ("GpiDeleteMetaFile");
HMF GpiLoadMetaFile(HAB, PSZ) asm ("GpiLoadMetaFile");
LONG GpiPlayMetaFile(HPS, HMF, LONG, PLONG, PLONG, LONG, PSZ) asm ("GpiPlayMetaFile");
BOOL GpiQueryMetaFileBits(HMF, LONG, LONG, PBYTE) asm ("GpiQueryMetaFileBits");
LONG GpiQueryMetaFileLength(HMF) asm ("GpiQueryMetaFileLength");
BOOL GpiSaveMetaFile(HMF, PSZ) asm ("GpiSaveMetaFile");
BOOL GpiSetMetaFileBits(HMF, LONG, LONG, PBYTE) asm ("GpiSetMetaFileBits");

#endif

#ifdef INCL_GPIDEFAULTS

BOOL GpiQueryDefArcParams(HPS, PARCPARAMS) asm ("GpiQueryDefArcParams");
BOOL GpiQueryDefAttrs(HPS, LONG, ULONG, PBUNDLE) asm ("GpiQueryDefAttrs");
BOOL GpiQueryDefTag(HPS, PLONG) asm ("GpiQueryDefTag");
BOOL GpiQueryDefViewingLimits(HPS, PRECTL) asm ("GpiQueryDefViewingLimits");
BOOL GpiSetDefArcParams(HPS, PARCPARAMS) asm ("GpiSetDefArcParams");
BOOL GpiSetDefAttrs(HPS, LONG, ULONG, PBUNDLE) asm ("GpiSetDefAttrs");
BOOL GpiSetDefTag(HPS, LONG) asm ("GpiSetDefTag");
BOOL GpiSetDefViewingLimits(HPS, PRECTL) asm ("GpiSetDefViewingLimits");

#endif


#ifdef INCL_GPIERRORS
#include <pmerr.h>
#endif

