#ifndef PMHELP_H

#define PMHELP_H

#define CMIC_HIDE_PANEL_ID				0x0000
#define CMIC_SHOW_PANEL_ID				0x0001
#define CMIC_TOGGLE_PANEL_ID				0x0002

#define HM_RESOURCEID					0
#define HM_PANELNAME					1
#define HM_MSG_BASE					0x0220
#define HM_DISMISS_WINDOW				HM_MSG_BASE+0x0001
#define HM_DISPLAY_HELP					HM_MSG_BASE+0x0002
#define HM_EXT_HELP					HM_MSG_BASE+0x0003
#define HM_GENERAL_HELP					HM_EXT_HELP
#define HM_SET_ACTIVE_WINDOW				HM_MSG_BASE+0x0004
#define HM_LOAD_HELP_TABLE				HM_MSG_BASE+0x0005
#define HM_CREATE_HELP_TABLE				HM_MSG_BASE+0x0006
#define HM_SET_HELP_WINDOW_TITLE			HM_MSG_BASE+0x0007
#define HM_SET_SHOW_PANEL_ID				HM_MSG_BASE+0x0008
#define HM_REPLACE_HELP_FOR_HELP			HM_MSG_BASE+0x0009
#define HM_REPLACE_USING_HELP				HM_REPLACE_HELP_FOR_HELP
#define HM_HELP_INDEX					HM_MSG_BASE+0x000a
#define HM_HELP_CONTENTS				HM_MSG_BASE+0x000b
#define HM_KEYS_HELP					HM_MSG_BASE+0x000c
#define HM_SET_HELP_LIBRARY_NAME			HM_MSG_BASE+0x000d
#define HM_ERROR					HM_MSG_BASE+0x000e
#define HM_HELPSUBITEM_NOT_FOUND			HM_MSG_BASE+0x000f
#define HM_QUERY_KEYS_HELP				HM_MSG_BASE+0x0010
#define HM_TUTORIAL					HM_MSG_BASE+0x0011
#define HM_EXT_HELP_UNDEFINED				HM_MSG_BASE+0x0012
#define HM_GENERAL_HELP_UNDEFINED			HM_EXT_HELP_UNDEFINED
#define HM_ACTIONBAR_COMMAND				HM_MSG_BASE+0x0013
#define HM_INFORM					HM_MSG_BASE+0x0014
#define HM_SET_OBJCOM_WINDOW				HM_MSG_BASE+0x0018
#define HM_UPDATE_OBJCOM_WINDOW_CHAIN			HM_MSG_BASE+0x0019
#define HM_QUERY_DDF_DATA				HM_MSG_BASE+0x001a
#define HM_INVALIDATE_DDF_DATA				HM_MSG_BASE+0x001b
#define HM_QUERY					HM_MSG_BASE+0x001c
#define HM_SET_COVERPAGE_SIZE				HM_MSG_BASE+0x001d
#define HM_NOTIFY					HM_MSG_BASE+0x0022
#define HM_SET_USERDATA					HM_MSG_BASE+0x0023

#define HMERR_NO_FRAME_WND_IN_CHAIN			0x00001001L
#define HMERR_INVALID_ASSOC_APP_WND			0x00001002L
#define HMERR_INVALID_ASSOC_HELP_INST			0x00001003L
#define HMERR_INVALID_DESTROY_HELP_INST			0x00001004L
#define HMERR_NO_HELP_INST_IN_CHAIN			0x00001005L
#define HMERR_INVALID_HELP_INSTANCE_HDL			0x00001006L
#define HMERR_INVALID_QUERY_APP_WND			0x00001007L
#define HMERR_HELP_INST_CALLED_INVALID			0x00001008L
#define HMERR_HELPTABLE_UNDEFINE			0x00001009L
#define HMERR_HELP_INSTANCE_UNDEFINE			0x0000100aL
#define HMERR_HELPITEM_NOT_FOUND			0x0000100bL
#define HMERR_INVALID_HELPSUBITEM_SIZE			0x0000100cL
#define HMERR_HELPSUBITEM_NOT_FOUND			0x0000100dL
#define HMERR_INDEX_NOT_FOUND				0x00002001L
#define HMERR_CONTENT_NOT_FOUND				0x00002002L
#define HMERR_OPEN_LIB_FILE				0x00002003L
#define HMERR_READ_LIB_FILE				0x00002004L
#define HMERR_CLOSE_LIB_FILE				0x00002005L
#define HMERR_INVALID_LIB_FILE				0x00002006L
#define HMERR_NO_MEMORY					0x00002007L
#define HMERR_ALLOCATE_SEGMENT				0x00002008L
#define HMERR_FREE_MEMORY				0x00002009L
#define HMERR_PANEL_NOT_FOUND				0x00002010L
#define HMERR_DATABASE_NOT_OPEN				0x00002011L
#define HMERR_LOAD_DLL					0x00002013L

#define HMPANELTYPE_NUMBER				0
#define HMPANELTYPE_NAME				1

#define HMQVP_NUMBER					0x0001
#define HMQVP_NAME					0x0002
#define HMQVP_GROUP					0x0003

#define HMQW_COVERPAGE					0x0001
#define HMQW_INDEX					0x0002
#define HMQW_TOC					0x0003
#define HMQW_SEARCH					0x0004
#define HMQW_VIEWPAGES					0x0005
#define HMQW_LIBRARY					0x0006
#define HMQW_VIEWPORT					0x0007
#define HMQW_OBJCOM_WINDOW				0x0008
#define HMQW_INSTANCE					0x0009
#define HMQW_ACTIVEVIEWPORT				0x000a
#define HMQW_GROUP_VIEWPORT				0x00f1
#define HMQW_RES_VIEWPORT				0x00f2

#define HWND_PARENT					(HWND)NULL

#define OPEN_COVERPAGE					0x0001
#define OPEN_PAGE					0x0002
#define OPEN_TOC					0x0004
#define OPEN_INDEX					0x0005
#define OPEN_HISTORY					0x0006
#define OPEN_SEARCH_HIT_LIST				0x0007
#define OPEN_LIBRARY					0x0008

#define SWAP_PAGE					0x0003

#define USERDATA					0x00f3

typedef int HELPSUBTABLE;
typedef int *PHELPSUBTABLE;

typedef struct _ACVP {
	ULONG cb;
	HAB hAB;
	HMQ hmq;
	ULONG ObjectID;
	HWND hWndParent;
	HWND hWndOwner;
	HWND hWndACVP;
} ACVP, *PACVP;

#pragma pack(2)

typedef struct _HELPTABLE {
	USHORT idAppWindow;
	PHELPSUBTABLE phstHelpSubTable;
	USHORT idExtPanel;
} HELPTABLE, *PHELPTABLE;

#pragma pack(4)

typedef struct _HELPINIT {
	ULONG cb;
	ULONG ulReturnCode;
	PSZ pszTutorialName;
	PHELPTABLE phtHelpTable;
	HMODULE hmodHelpTableModule;
	HMODULE hmodAccelActionBarModule;
	ULONG idAccelTable;
	ULONG idActionBar;
	PSZ pszHelpWindowTitle;
	ULONG fShowPanelId;
	PSZ pszHelpLibraryName;
} HELPINIT, *PHELPINIT;

BOOL WinAssociateHelpInstance(HWND, HWND) asm ("WinAssociateHelpInstance");
HWND WinCreateHelpInstance(HAB, PHELPINIT) asm ("WinCreateHelpInstance");
BOOL WinCreateHelpTable (HWND, PHELPTABLE) asm ("WinCreateHelpTable");
BOOL WinDestroyHelpInstance(HWND) asm ("WinDestroyHelpInstance");
BOOL WinLoadHelpTable (HWND, USHORT, HMODULE) asm ("WinLoadHelpTable");
HWND WinQueryHelpInstance(HWND) asm ("WinQueryHelpInstance");


#ifdef INCL_DDF

#define ART_RUNIN					0x10L
#define ART_LEFT					0x01L
#define ART_RIGHT					0x02L
#define ART_CENTER					0x04L

#define CLR_UNCHANGED					(-6L)

#define HMBT_NONE					1L
#define HMBT_ALL					2L
#define HMBT_FIT					3L

#define HMERR_DDF_MEMORY				0x3001
#define HMERR_DDF_ALIGN_TYPE				0x3002
#define HMERR_DDF_BACKCOLOR				0x3003
#define HMERR_DDF_FORECOLOR				0x3004
#define HMERR_DDF_FONTSTYLE				0x3005
#define HMERR_DDF_REFTYPE				0x3006
#define HMERR_DDF_LIST_UNCLOSED				0x3007
#define HMERR_DDF_LIST_UNINITIALIZED			0x3008
#define HMERR_DDF_LIST_BREAKTYPE			0x3009
#define HMERR_DDF_LIST_SPACING				0x300A
#define HMERR_DDF_HINSTANCE				0x300B
#define HMERR_DDF_EXCEED_MAX_LENGTH			0x300C
#define HMERR_DDF_EXCEED_MAX_INC			0x300D
#define HMERR_DDF_INVALID_DDF				0x300E
#define HMERR_DDF_FORMAT_TYPE				0x300F
#define HMERR_DDF_INVALID_PARM				0x3010
#define HMERR_DDF_INVALID_FONT				0x3011
#define HMERR_DDF_SEVERE				0x3012

#define HMLS_SINGLELINE					1L
#define HMLS_DOUBLELINE					2L

#define REFERENCE_BY_ID					0L
#define REFERENCE_BY_RES				1L

typedef VOID *HDDF;

BOOL DdfBeginList(HDDF, ULONG, ULONG, ULONG) asm ("DdfBeginList");
BOOL DdfBitmap(HDDF, HBITMAP, ULONG) asm ("DdfBitmap");
BOOL DdfEndList(HDDF) asm ("DdfEndList");
BOOL DdfHyperText(HDDF, PSZ, PSZ, ULONG) asm ("DdfHyperText");
BOOL DdfInform(HDDF, PSZ, ULONG) asm ("DdfInform");
HDDF DdfInitialize(HWND, ULONG, ULONG) asm ("DdfInitialize");
BOOL DdfListItem(HDDF, PSZ, PSZ) asm ("DdfListItem");
BOOL DdfMetafile(HDDF, HMF, PRECTL) asm ("DdfMetafile");
BOOL DdfPara(HDDF) asm ("DdfPara");
BOOL DdfSetColor(HDDF, COLOR, COLOR) asm ("DdfSetColor");
BOOL DdfSetFont(HDDF, PSZ, ULONG, ULONG) asm ("DdfSetFont");
BOOL DdfSetFontStyle(HDDF, ULONG) asm ("DdfSetFontStyle");
BOOL DdfSetFormat(HDDF, ULONG) asm ("DdfSetFormat");
BOOL DdfSetTextAlign(HDDF, ULONG) asm ("DdfSetTextAlign");
BOOL DdfText(HDDF, PSZ) asm ("DdfText");

#endif
#endif

