#define MAXNAMEL					60

#define XYF_NOAUTOCLOSE					0x0008
#define XYF_MINIMIZED					0x0004
#define XYF_MAXIMIZED					0x0002
#define XYF_INVISIBLE					0x0001
#define XYF_NORMAL					0X0000

typedef LHANDLE HINI;
typedef HINI *PHINI;

#define HINI_PROFILE					(HINI)NULL
#define HINI_USERPROFILE				(HINI)-1L
#define HINI_SYSTEMPROFILE				(HINI)-2L
#define HINI_USER					HINI_USERPROFILE
#define HINI_SYSTEM					HINI_SYSTEMPROFILE

#define SAF_INSTALLEDCMDLINE				0x0001
#define SAF_STARTCHILDAPP				0x0002

typedef LHANDLE HPROGRAM;
typedef HPROGRAM *PHPROGRAM;

typedef struct _PRFPROFILE {
	ULONG cchUserName;
	PSZ pszUserName;
	ULONG cchSysName;
	PSZ pszSysName;
} PRFPROFILE, *PPRFPROFILE;

typedef struct _XYWINSIZE {
	SHORT x;
	SHORT y;
	SHORT cx;
	SHORT cy;
	USHORT fsWindow;
} XYWINSIZE, *PXYWINSIZE;


#if (defined(INCL_WINPROGRAMLIST)||defined(INCL_WINSHELLDATA))

#define MAXPATHL 128

#define SGH_ROOT					(HPROGRAM)-1L

#define SHE_VISIBLE					(BYTE)0x00
#define SHE_INVISIBLE					(BYTE)0x01
#define SHE_RESERVED					(BYTE)0xFF
#define SHE_UNPROTECTED					(BYTE)0x00
#define SHE_PROTECTED					(BYTE)0x02

typedef struct _HPROGARRAY {
	HPROGRAM ahprog[1];
} HPROGARRAY, *PHPROGARRAY;

typedef char PROGCATEGORY;
typedef PROGCATEGORY *PPROGCATEGORY;

#define PROG_DEFAULT					(PROGCATEGORY)0
#define PROG_FULLSCREEN					(PROGCATEGORY)1
#define PROG_WINDOWABLEVIO				(PROGCATEGORY)2
#define PROG_PM						(PROGCATEGORY)3
#define PROG_GROUP					(PROGCATEGORY)5
#define PROG_REAL					(PROGCATEGORY)4
#define PROG_VDM					(PROGCATEGORY)4
#define PROG_WINDOWEDVDM				(PROGCATEGORY)7
#define PROG_DLL					(PROGCATEGORY)6
#define PROG_PDD					(PROGCATEGORY)8
#define PROG_VDD					(PROGCATEGORY)9
#define PROG_WINDOW_REAL				(PROGCATEGORY)10
#define PROG_WINDOW_PROT				(PROGCATEGORY)11
#define PROG_WINDOW_AUTO				(PROGCATEGORY)12
#define PROG_RESERVED					(PROGCATEGORY)255

typedef struct _PROGTYPE {
	PROGCATEGORY progc;
	UCHAR fbVisible;
} PROGTYPE, *PPROGTYPE;

typedef struct _PIBSTRUCT {
	PROGTYPE progt;
	CHAR szTitle[MAXNAMEL+1];
	CHAR szIconFileName[MAXPATHL+1];
	CHAR szExecutable[MAXPATHL+1];
	CHAR szStartupDir[MAXPATHL+1];
	XYWINSIZE xywinInitial;
	USHORT res1;
	LHANDLE res2;
	USHORT cchEnvironmentVars;
	PCH pchEnvironmentVars;
	USHORT cchProgramParameter;
	PCH pchProgramParameter;
} PIBSTRUCT, *PPIBSTRUCT;

typedef struct _PROGDETAILS {
	ULONG Length;
	PROGTYPE progt;
	USHORT pad1[3];
	PSZ pszTitle;
	PSZ pszExecutable;
	PSZ pszParameters;
	PSZ pszStartupDir;
	PSZ pszIcon;
	PSZ pszEnvironment;
	SWP swpInitial;
	USHORT pad2[5];
} PROGDETAILS, *PPROGDETAILS;

typedef struct _PROGRAMENTRY {
	HPROGRAM hprog;
	PROGTYPE progt;
	CHAR szTitle[MAXNAMEL+1];
} PROGRAMENTRY, *PPROGRAMENTRY;

typedef struct _PROGTITLE {
	HPROGRAM hprog;
	PROGTYPE progt;
	USHORT pad1[3];
	PSZ pszTitle;
} PROGTITLE, *PPROGTITLE;

typedef struct _QFEOUTBLK {
	USHORT Total;
	USHORT Count;
	HPROGRAM ProgramArr[1];
} QFEOUTBLK, *PQFEOUTBLK;

#endif

typedef LHANDLE HSWITCH;
typedef HSWITCH *PHSWITCH;
typedef LHANDLE HAPP;


#if (defined(INCL_WINSWITCHLIST)||!defined(INCL_NOCOMMON))

#define SWL_VISIBLE					(BYTE)0x04
#define SWL_INVISIBLE					(BYTE)0x01
#define SWL_GRAYED					(BYTE)0x02
#define SWL_JUMPABLE					(BYTE)0x02
#define SWL_NOTJUMPABLE					(BYTE)0x01

typedef struct _SWCNTRL {
	HWND hwnd;
	HWND hwndIcon;
	HPROGRAM hprog;
	PID idProcess;
	USHORT idSession;
	UCHAR uchVisibility;
	UCHAR fbJump;
	CHAR szSwtitle[MAXNAMEL+1];
	BYTE bProgType;
} SWCNTRL, *PSWCNTRL;


HSWITCH WinAddSwitchEntry(PSWCNTRL) asm ("WinAddSwitchEntry");
HAPP WinHAPPfromPID(USHORT) asm ("WinHAPPfromPID");
USHORT WinRemoveSwitchEntry(HSWITCH) asm ("WinRemoveSwitchEntry");

#endif


#ifdef INCL_WINSWITCHLIST

typedef struct _SWENTRY {
	HSWITCH hswitch;
	SWCNTRL swctl;
} SWENTRY, *PSWENTRY;

typedef struct _SWBLOCK {
	USHORT cswentry;
	SWENTRY aswentry[1];
} SWBLOCK, *PSWBLOCK;

USHORT WinChangeSwitchEntry(HSWITCH, PSWCNTRL) asm ("WinChangeSwitchEntry");
HSWITCH WinCreateSwitchEntry(HAB, PSWCNTRL) asm ("WinCreateSwitchEntry");
HSWITCH WinHSWITCHfromHAPP(HAPP) asm ("WinHSWITCHfromHAPP");
USHORT WinQuerySessionTitle(HAB, USHORT, PSZ, USHORT) asm ("WinQuerySessionTitle");
USHORT WinQuerySwitchEntry(HSWITCH, PSWCNTRL) asm ("WinQuerySwitchEntry");
HSWITCH WinQuerySwitchHandle(HWND, PID) asm ("WinQuerySwitchHandle");
USHORT WinQuerySwitchList(HAB, PSWBLOCK, USHORT) asm ("WinQuerySwitchList");
USHORT WinQueryTaskSizePos(HAB, USHORT, PSWP) asm ("WinQueryTaskSizePos");
USHORT WinQueryTaskTitle(USHORT, PSZ, USHORT) asm ("WinQueryTaskTitle");
USHORT WinSwitchToProgram(HSWITCH) asm ("WinSwitchToProgram");

#endif


#ifdef INCL_ERRORS
#define INCL_SHLERRORS
#endif

#ifdef INCL_WINSHELLDATA

HPROGRAM PrfAddProgram(HINI, PPROGDETAILS, HPROGRAM) asm ("PrfAddProgram");
BOOL PrfChangeProgram(HINI, HPROGRAM, PPROGDETAILS) asm ("PrfChangeProgram");
BOOL PrfCloseProfile(HINI) asm ("PrfCloseProfile");
HPROGRAM PrfCreateGroup(HINI, PSZ, UCHAR) asm ("PrfCreateGroup");
BOOL PrfDestroyGroup(HINI, HPROGRAM) asm ("PrfDestroyGroup");
HINI PrfOpenProfile(HAB, PSZ) asm ("PrfOpenProfile");
ULONG PrfQueryDefinition(HINI, HPROGRAM, PPROGDETAILS, ULONG) asm ("PrfQueryDefinition");
BOOL PrfQueryProfile(HAB, PPRFPROFILE) asm ("PrfQueryProfile");
BOOL PrfQueryProfileData(HINI, PSZ, PSZ, PVOID, PULONG) asm ("PrfQueryProfileData");
SHORT PrfQueryProfileInt(HINI, PSZ, PSZ, SHORT) asm ("PrfQueryProfileInt");
BOOL PrfQueryProfileSize(HINI, PSZ, PSZ, PULONG) asm ("PrfQueryProfileSize");
ULONG PrfQueryProfileString(HINI, PSZ, PSZ, PSZ, PVOID, ULONG) asm ("PrfQueryProfileString");
PROGCATEGORY PrfQueryProgramCategory(HINI, PSZ) asm ("PrfQueryProgramCategory");
ULONG PrfQueryProgramHandle(HINI, PSZ, PHPROGARRAY, ULONG, PULONG) asm ("PrfQueryProgramHandle");
ULONG PrfQueryProgramTitles(HINI, HPROGRAM, PPROGTITLE, ULONG, PULONG) asm ("PrfQueryProgramTitles");
BOOL PrfRemoveProgram(HINI,HPROGRAM) asm ("PrfRemoveProgram");
BOOL PrfReset(HAB, PPRFPROFILE) asm ("PrfReset");
BOOL PrfWriteProfileData(HINI, PSZ, PSZ, PVOID, ULONG) asm ("PrfWriteProfileData");
BOOL PrfWriteProfileString(HINI, PSZ, PSZ, PSZ) asm ("PrfWriteProfileString");

#endif

#ifdef INCL_SHLERRORS
#include <pmerr.h>
#endif

#ifdef INCL_WINPROGRAMLIST

HAPP WinStartApp(HWND, PPROGDETAILS, PSZ, PVOID, USHORT) asm ("WinStartApp");

#endif

