#ifdef INCL_ERRORS
#define INCL_SPLERRORS
#endif

#define QPDAT_ADDRESS					0
#define QPDAT_DRIVER_NAME				1
#define QPDAT_DRIVER_DATA				2
#define QPDAT_DATA_TYPE					3
#define QPDAT_COMMENT					4
#define QPDAT_PROC_PARAMS				5
#define QPDAT_SPL_PARAMS				6
#define QPDAT_NET_PARAMS				7
#define QPDAT_DOC_NAME					8
#define QPDAT_QUEUE_NAME				9
#define QPDAT_TOKEN					10
#define QPDAT_JOBID					11

#define SPL_INI_SPOOLER					"PM_SPOOLER"
#define SPL_INI_QUEUE					"PM_SPOOLER_QUEUE"
#define SPL_INI_PRINTER					"PM_SPOOLER_PRINTER"
#define SPL_INI_PRINTERDESCR				"PM_SPOOLER_PRINTER_DESCR"
#define SPL_INI_QUEUEDESCR				"PM_SPOOLER_QUEUE_DESCR"
#define SPL_INI_QUEUEDD					"PM_SPOOLER_QUEUE_DD"
#define SPL_INI_QUEUEDDDATA				"PM_SPOOLER_QUEUE_DDDATA"
#define SPL_ERROR					0L
#define SPL_OK						1L

#define SPLC_ABORT					1
#define SPLC_PAUSE					2
#define SPLC_CONTINUE					3

#define SPLDATA_PRINTERJAM				0x0001
#define SPLDATA_FORMCHGREQD				0x0002
#define SPLDATA_CARTCHGREQD				0x0004
#define SPLDATA_PENCHGREQD				0x0008
#define SPLDATA_DATAERROR				0x0010
#define SPLDATA_UNEXPECTERROR				0x0020
#define SPLDATA_OTHER					0x8000

#define SPLINFO_QPERROR					0x0001
#define SPLINFO_DDERROR					0x0002
#define SPLINFO_SPLERROR				0x0004
#define SPLINFO_OTHERERROR				0x0080
#define SPLINFO_INFORMATION				0x0100
#define SPLINFO_WARNING					0x0200
#define SPLINFO_ERROR					0x0400
#define SPLINFO_SEVERE					0x0800
#define SPLINFO_USERINTREQD				0x1000

#define SSQL_ERROR					(-1L)

typedef PSZ *PQMOPENDATA;
typedef PSZ *PQPOPENDATA;
typedef LHANDLE HPROC;
typedef LHANDLE HSPL;
typedef LHANDLE HSTD;
typedef HSTD *PHSTD;

typedef unsigned long SPLERR;

typedef struct _SQPOPENDATA {
	PSZ pszLogAddress;
	PSZ pszDriverName;
	PDRIVDATA pdriv;
	PSZ pszDataType;
	PSZ pszComment;
	PSZ pszProcParams;
	PSZ pszSpoolParams;
	PSZ pszNetworkParams;
	PSZ pszDocName;
	PSZ pszQueueName;
	PSZ pszToken;
	USHORT idJobId;
} SQPOPENDATA, *PSQPOPENDATA;

BOOL32 Spl32QmAbort(HSPL) asm ("Spl32QmAbort");
BOOL32 Spl32QmAbortDoc(HSPL) asm ("Spl32QmAbortDoc");
BOOL32 Spl32QmClose(HSPL) asm ("Spl32QmClose");
BOOL32 Spl32QmEndDoc(HSPL) asm ("Spl32QmEndDoc");
ULONG Spl32MessageBox(PSZ, ULONG, ULONG,PSZ, PSZ, ULONG, ULONG) asm ("Spl32MessageBox");
HSPL Spl32QmOpen(PSZ, LONG, PQMOPENDATA) asm ("Spl32QmOpen");
BOOL32 Spl32QmStartDoc(HSPL, PSZ) asm ("Spl32QmStartDoc");
BOOL32 Spl32QmWrite(HSPL, LONG, PVOID) asm ("Spl32QmWrite");
BOOL32 Spl32StdClose(HDC) asm ("Spl32StdClose");
BOOL32 Spl32StdDelete(HSTD) asm ("Spl32StdDelete");
BOOL32 Spl32StdGetBits(HSTD, LONG, LONG, PCH) asm ("Spl32StdGetBits");
BOOL32 Spl32StdOpen(HDC) asm ("Spl32StdOpen");
LONG Spl32StdQueryLength(HSTD) asm ("Spl32StdQueryLength");
BOOL32 Spl32StdStart(HDC) asm ("Spl32StdStart");
HSTD Spl32StdStop(HDC) asm ("Spl32StdStop");
SPLERR SplControlDevice(PSZ, PSZ, ULONG) asm ("SplControlDevice");
SPLERR SplCopyJob(PSZ, PSZ, ULONG, PSZ, PSZ, PULONG) asm ("SplCopyJob");
SPLERR SplCreateDevice(PSZ, ULONG, PVOID, ULONG) asm ("SplCreateDevice");
SPLERR SplCreateQueue(PSZ, ULONG, PVOID, ULONG) asm ("SplCreateQueue");
SPLERR SplDeleteDevice(PSZ, PSZ) asm ("SplDeleteDevice");
SPLERR SplDeleteJob(PSZ, PSZ, ULONG) asm ("SplDeleteJob");
SPLERR SplDeleteQueue(PSZ, PSZ) asm ("SplDeleteQueue");
SPLERR SplEnumDevice(PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumDevice");
SPLERR SplEnumDriver(PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumDriver");
SPLERR SplEnumJob(PSZ, PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumJob");
SPLERR SplEnumPort(PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumPort");
SPLERR SplEnumPrinter (PSZ, ULONG, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumPrinter");
SPLERR SplEnumQueue(PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumQueue");
SPLERR SplEnumQueueProcessor(PSZ, ULONG, PVOID, ULONG, PULONG, PULONG, PULONG, PVOID) asm ("SplEnumQueueProcessor");
SPLERR SplHoldJob(PSZ, PSZ, ULONG) asm ("SplHoldJob");
SPLERR SplHoldQueue(PSZ, PSZ) asm ("SplHoldQueue");
SPLERR SplPurgeQueue(PSZ, PSZ) asm ("SplPurgeQueue");
HPROC SplQpOpen(LONG, PQPOPENDATA) asm ("SplQpOpen");
BOOL SplQpPrint(HPROC, PSZ) asm ("SplQpPrint");
BOOL SplQpClose(HPROC) asm ("SplQpClose");
BOOL SplQpControl(HPROC, LONG) asm ("SplQpControl");
BOOL SplQpQueryDt(PLONG, PSZ *) asm ("SplQpQueryDt");
BOOL SplQpInstall(HWND) asm ("SplQpInstall");
SPLERR SplQueryDevice(PSZ, PSZ, ULONG, PVOID, ULONG, PULONG) asm ("SplQueryDevice");
SPLERR SplQueryJob(PSZ, PSZ, ULONG, ULONG, PVOID, ULONG, PULONG) asm ("SplQueryJob");
SPLERR SplQueryQueue(PSZ, PSZ, ULONG, PVOID, ULONG, PULONG) asm ("SplQueryQueue");
SPLERR SplReleaseJob(PSZ, PSZ, ULONG) asm ("SplReleaseJob");
SPLERR SplReleaseQueue(PSZ, PSZ) asm ("SplReleaseQueue");
SPLERR SplSetDevice(PSZ, PSZ, ULONG, PVOID, ULONG, ULONG) asm ("SplSetDevice");
SPLERR SplSetJob(PSZ, PSZ, ULONG, ULONG, PVOID, ULONG, ULONG) asm ("SplSetJob");
SPLERR SplSetQueue(PSZ, PSZ, ULONG, PVOID, ULONG, ULONG) asm ("SplSetQueue");

#ifdef INCL_SPLERRORS
#include <pmerr.h>
#endif

#ifdef INCL_SPLDOSPRINT

#define CNLEN						15

#define DRIV_DEVICENAME_SIZE				31
#define DRIV_NAME_SIZE					8

#define DTLEN						9

#define FORMNAME_SIZE					31

#define MAXCOMMENTSZ					48

#define PDLEN						8

#define PRD_STATUS_MASK					0x0003
#define PRD_DEVSTATUS					0x0ffc
#define PRD_ACTIVE					0
#define PRD_PAUSED					1
#define PRD_DELETE					0
#define PRD_PAUSE					1
#define PRD_CONT					2
#define PRD_RESTART					3
#define PRD_LOGADDR_PARMNUM				3
#define PRD_COMMENT_PARMNUM				7
#define PRD_DRIVERS_PARMNUM				8
#define PRD_TIMEOUT_PARMNUM				10
#define PRD_DRIVER_DATA_PARMNUM				11

#define PRINTERNAME_SIZE				32

#define PRJ_NOTIFYNAME_PARMNUM				3
#define PRJ_DATATYPE_PARMNUM				4
#define PRJ_PARMS_PARMNUM				5
#define PRJ_POSITION_PARMNUM				6
#define PRJ_JOBFILEINUSE_PARMNUM			7
#define PRJ_COMMENT_PARMNUM				11
#define PRJ_DOCUMENT_PARMNUM				12
#define PRJ_STATUSCOMMENT_PARMNUM			13
#define PRJ_PRIORITY_PARMNUM				14
#define PRJ_PROCPARMS_PARMNUM				16
#define PRJ_DRIVERDATA_PARMNUM				18
#define PRJ_MAXPARMNUM					18
#define PRJ_QSTATUS					0x0003
#define PRJ_DEVSTATUS					0x0ffc
#define PRJ_COMPLETE					0x0004
#define PRJ_INTERV					0x0008
#define PRJ_ERROR					0x0010
#define PRJ_DESTOFFLINE					0x0020
#define PRJ_DESTPAUSED					0x0040
#define PRJ_NOTIFY					0x0080
#define PRJ_DESTNOPAPER					0x0100
#define PRJ_DESTFORMCHG					0x0200
#define PRJ_DESTCRTCHG					0x0400
#define PRJ_DESTPENCHG					0x0800
#define PRJ_JOBFILEINUSE				0x4000
#define PRJ_DELETED					0x8000
#define PRJ_QS_QUEUED					0
#define PRJ_QS_PAUSED					1
#define PRJ_QS_SPOOLING					2
#define PRJ_QS_PRINTING					3
#define PRJ_MAX_PRIORITY				99
#define PRJ_MIN_PRIORITY				1
#define PRJ_NO_PRIORITY					0

#define PRQ_PRIORITY_PARMNUM				2
#define PRQ_STARTTIME_PARMNUM				3
#define PRQ_UNTILTIME_PARMNUM				4
#define PRQ_SEPARATOR_PARMNUM				5
#define PRQ_PROCESSOR_PARMNUM				6
#define PRQ_DESTINATIONS_PARMNUM				7
#define PRQ_PARMS_PARMNUM				8
#define PRQ_COMMENT_PARMNUM				9
#define PRQ_TYPE_PARMNUM				10
#define PRQ_PRINTERS_PARMNUM				12
#define PRQ_DRIVERNAME_PARMNUM				13
#define PRQ_DRIVERDATA_PARMNUM				14
#define PRQ_REMOTE_COMPUTER_PARMNUM			15
#define PRQ_REMOTE_QUEUE_PARMNUM			16
#define PRQ_MAXPARMNUM					16
#define PRQ_MAX_PRIORITY				1
#define PRQ_DEF_PRIORITY				5
#define PRQ_MIN_PRIORITY				9
#define PRQ_NO_PRIORITY					0
#define PRQ_STATUS_MASK					3
#define PRQ_ACTIVE					0
#define PRQ_PAUSED					1
#define PRQ_ERROR					2
#define PRQ_PENDING					3

#define PRQ3_PAUSED					0x1
#define PRQ3_PENDING					0x2
#define PRQ3_TYPE_RAW					0x1

#define QNLEN						12

#define QP_DATATYPE_SIZE				15

#define SPL_PR_QUEUE					0x00000001
#define SPL_PR_DIRECT_DEVICE				0x00000002
#define SPL_PR_QUEUED_DEVICE				0x00000004
#define SPL_PR_LOCAL_ONLY				0x00000100

#define UNLEN						20

typedef struct _DRIVPROPS {
	PSZ pszKeyName;
	ULONG cbBuf;
	PVOID pBuf;
} DRIVPROPS, *PDRIVPROPS, *NPDRIVPROPS;

typedef struct _PRDINFO {
	CHAR szName[PDLEN+1];
	CHAR szUserName[UNLEN+1];
	USHORT uJobId;
	USHORT fsStatus;
	PSZ pszStatus;
	USHORT time;
} PRDINFO, *PPRDINFO, *NPPRDINFO;

typedef struct _PRDINFO3 {
	PSZ pszPrinterName;
	PSZ pszUserName;
	PSZ pszLogAddr;
	USHORT uJobId;
	USHORT fsStatus;
	PSZ pszStatus;
	PSZ pszComment;
	PSZ pszDrivers;
	USHORT time;
	USHORT usTimeOut;
} PRDINFO3, *PPRDINFO3, *NPPRDINFO3;

typedef struct _PRDINFO4 {
	PSZ pszPrinterName;
	PSZ pszUserName;
	PSZ pszLogAddr;
	USHORT uJobId;
	USHORT fsStatus;
	PSZ pszStatus;
	PSZ pszComment;
	PSZ pszDrivers;
	USHORT time;
	USHORT usTimeOut;
	ULONG cDriverProps;
} PRDINFO4, *PPRDINFO4, *NPPRDINFO4;

typedef struct _PRDRIVINFO {
	CHAR szDrivName[DRIV_NAME_SIZE+1+DRIV_DEVICENAME_SIZE+1];
} PRDRIVINFO, *PPRDRIVINFO, *NPPRDRIVINFO;

typedef struct _PRINTERINFO {
	ULONG flType;
	PSZ pszComputerName;
	PSZ pszPrintDestinationName;
	PSZ pszDescription;
	PSZ pszLocalName;
} PRINTERINFO, *PPRINTERINFO ;

typedef struct _PRJINFO {
	USHORT uJobId;
	CHAR szUserName[UNLEN+1];
	CHAR pad_1;
	CHAR szNotifyName[CNLEN+1];
	CHAR szDataType[DTLEN+1];
	PSZ pszParms;
	USHORT uPosition;
	USHORT fsStatus;
	PSZ pszStatus;
	ULONG ulSubmitted;
	ULONG ulSize;
	PSZ pszComment;
} PRJINFO, *PPRJINFO, *NPPRJINFO;

typedef struct _PRJINFO2 {
	USHORT uJobId;
	USHORT uPriority;
	PSZ pszUserName;
	USHORT uPosition;
	USHORT fsStatus;
	ULONG ulSubmitted;
	ULONG ulSize;
	PSZ pszComment;
	PSZ pszDocument;
} PRJINFO2, *PPRJINFO2, *NPPRJINFO2;

typedef struct _PRJINFO3 {
	USHORT uJobId;
	USHORT uPriority;
	PSZ pszUserName;
	USHORT uPosition;
	USHORT fsStatus;
	ULONG ulSubmitted;
	ULONG ulSize;
	PSZ pszComment;
	PSZ pszDocument;
	PSZ pszNotifyName;
	PSZ pszDataType;
	PSZ pszParms;
	PSZ pszStatus;
	PSZ pszQueue;
	PSZ pszQProcName;
	PSZ pszQProcParms;
	PSZ pszDriverName;
	PDRIVDATA pDriverData;
	PSZ pszPrinterName;
} PRJINFO3, *PPRJINFO3, *NPPRJINFO3;

typedef struct _PRPORTINFO {
	CHAR szPortName[PDLEN+1];
} PRPORTINFO, *PPRPORTINFO;

typedef struct _PRPORTINFO1 {
	PSZ pszPortName ;
	PSZ pszPortDriverName ;
	PSZ pszPortDriverPathName ;
} PRPORTINFO1, *PPRPORTINFO1, *NPPRPORTINFO1;

typedef struct _PRQINFO {
	CHAR szName[QNLEN+1];
	CHAR pad_1;
	USHORT uPriority;
	USHORT uStartTime;
	USHORT uUntilTime;
	PSZ pszSepFile;
	PSZ pszPrProc;
	PSZ pszDestinations;
	PSZ pszParms;
	PSZ pszComment;
	USHORT fsStatus;
	USHORT cJobs;
} PRQINFO, *PPRQINFO, *NPPRQINFO;

typedef struct _PRQINFO3 {
	PSZ pszName;
	USHORT uPriority;
	USHORT uStartTime;
	USHORT uUntilTime;
	USHORT fsType;
	PSZ pszSepFile;
	PSZ pszPrProc;
	PSZ pszParms;
	PSZ pszComment;
	USHORT fsStatus;
	USHORT cJobs;
	PSZ pszPrinters;
	PSZ pszDriverName;
	PDRIVDATA pDriverData;
} PRQINFO3, *PPRQINFO3, *NPPRQINFO3;

typedef struct _PRQINFO6 {
	PSZ pszName;
	USHORT uPriority;
	USHORT uStartTime;
	USHORT uUntilTime;
	USHORT fsType;
	PSZ pszSepFile;
	PSZ pszPrProc;
	PSZ pszParms;
	PSZ pszComment;
	USHORT fsStatus;
	USHORT cJobs;
	PSZ pszPrinters;
	PSZ pszDriverName;
	PDRIVDATA pDriverData;
	PSZ pszRemoteComputerName;
	PSZ pszRemoteQueueName;
} PRQINFO6, *PPRQINFO6, *NPPRQINFO6;

typedef struct _PRQPROCINFO {
	CHAR szQProcName[QNLEN+1];
} PRQPROCINFO, *PPRQPROCINFO, *NPPRQPROCINFO;

#endif

#ifdef INCL_SPLFSE

VOID Prt32Abort(HFILE) asm ("Prt32Abort");
ULONG Prt32Close(HFILE) asm ("Prt32Close");
ULONG Prt32DevIOCtl(PVOID, PVOID, ULONG, ULONG, HFILE) asm ("Prt32DevIOCtl");
ULONG Prt32Open(PSZ, PHFILE, PULONG, ULONG, ULONG, ULONG, ULONG, ULONG) asm ("Prt32Open");
ULONG Prt32Write(HFILE, PVOID, ULONG, PULONG) asm ("Prt32Write");

#endif

