/*****************************************************************************/
/*                                                                           */
/* This file is part of a program which creates and manages a Microsoft .LIB */
/* format file containing Microsoft standard object modules. This version is */
/* specifically for use with IBM OS/2 2.0.                                   */
/*                                                                           */
/* Copyright (C) 1992 Jonathan Sykes (jsykes@aol.com)                        */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* General Public License for more details.                                  */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   File Name :  GetWord.c                                                  */
/*                                                                           */
/*   Called By :  AddPublics.c, DoPub2Def.c, GetRecLen.c, ReadLibHeader.c    */
/*                                                                           */
/*   Calls     :  GetByte.c                                                  */
/*                                                                           */
/*   Date      :  29-Aug-92                                                  */
/*                                                                           */
/*****************************************************************************/
Word GetWord (fp, swap)
FILE  *fp;
Bool   swap;
  {
  Byte c1, c2;

  if (swap)
    {
    c1 = GetByte(fp);
    c2 = GetByte(fp);
    return ((c2 << 8) + c1);	/* swap   - Lo Hi */
    }
  else
    {
    c1 = GetByte(fp);
    c2 = GetByte(fp);
    return ((c1 << 8) + c2);	/* noswap - Hi Lo */
    }
  }
