#define INCL_DOSPROCESS
#define INCL_DOSERRORS
#include <os2.h>
#include <errno.h>
#include <process.h>

ULONG Dos32ExecPgm() asm ("Dos32ExecPgm");

int spawnl (int modeflag, char *path, char *arg0, ...)
{
   int i;
   ULONG rc;
   int total_length;
   char *arg_strings;
   char *ptr;
   RESULTCODES ReturnCodes;
   char ObjNameBuf[512];
   char exe_name[512];
   char **argptr;

   strcpy (exe_name, path);

   if (strstr (exe_name, ".exe") == 0 && strstr (exe_name, ".EXE") == 0)
      strcat (exe_name, ".EXE");

   /* construct the command args for DosExecPgm */

   for (argptr = &arg0, total_length = 1; *argptr; ++argptr)
      total_length += strlen (*argptr) + 1;

   arg_strings = (char *)malloc (total_length);

   for (argptr = &arg0, ptr = arg_strings; *argptr; ++argptr)
   {
      bcopy (*argptr, ptr, strlen (*argptr)+1);
      ptr += strlen (*argptr);
      if (argptr == &arg0)
         ptr++;
      else
         *ptr++ = ' ';
   }

   *ptr = '\0';

   switch (modeflag)
   {
      case P_WAIT:    /* Wait for completion */
         rc = Dos32ExecPgm (&ObjNameBuf[0],
                            512,
                            EXEC_SYNC,
                            arg_strings,
                            NULL,
                            &ReturnCodes,
                            exe_name);

         if (rc)
         {
            if (rc == ERROR_FILE_NOT_FOUND || rc == ERROR_PATH_NOT_FOUND)
            {
               errno = ENOENT;
               return (-1);
            }

            errno = EIO;
            return (-1);
         }

         return (ReturnCodes.codeResult);
         break;

      case P_NOWAIT:  /* Create a child and return */
         rc = Dos32ExecPgm (&ObjNameBuf[0],
                            512,
                            EXEC_ASYNCRESULT,
                            arg_strings,
                            NULL,
                            &ReturnCodes,
                            exe_name);

         if (rc)
         {
            if (rc == ERROR_FILE_NOT_FOUND || rc == ERROR_PATH_NOT_FOUND)
            {
               errno = ENOENT;
               return (-1);
            }

            errno = EIO;
            return (-1);
         }

         return (ReturnCodes.codeTerminate);
         break;

      default:        /* oops... */
         errno = EINVAL;
         return (-1);
         break;
   }
}

