/* Copyright (c) 1992 Colin Jensen.  All Rights Reserved. */


/*
 * This file was generated by the SOM Compiler.
 * FileName: ..\..\ibmh\wpfsys.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter emith: 1.11
 */

/*
 * 
 *  Module Header
 * 
 *  Module Name: WPFSYS
 * 
 *  OS/2 Presentation Manager Workplace class definitions
 * 
 *  Copyright (c) International Business Machines Corporation 1991, 1992
 * 
 */


#ifndef wpfsys_h
#define wpfsys_h


#include <som.h>

/*
 * Define the class name as an object type
 */
#ifndef WPFileSystem
#define WPFileSystem SOMAny
#endif
#include "wpobject.h"

/*
 * Passthru lines: File: "C.h", "after"
 */
/* Structure used to read + write the .CLASSINFO ea */

      typedef struct _INFOCLASS
      {
         ULONG    flags;
         PSZ      pszClass;
         ULONG    cbObjData;
         POBJDATA pObjData;
      } INFOCLASS;
      typedef INFOCLASS * PINFOCLASS;

      /* FILEDETAILS structure used for details view */

    typedef struct _FILEDETAILS
    {
       PSZ      pszRealName;     /* Real name */
       ULONG    ulSize;          /* Size of the file */
       CDATE    cdateLastMod;    /* Last modification date */
       CTIME    ctimeLastMod;    /* Last modification time */
       CDATE    cdateLastAccess; /* Last access date */
       CTIME    ctimeLastAccess; /* Last access time */
       CDATE    cdateCreation;   /* Date of creation */
       CTIME    ctimeCreation;   /* Time of creation */
       ULONG    ulFlags;         /* File flags */
    }  FILEDETAILS;

    typedef FILEDETAILS * PFILEDETAILS;

    #define NUM_FILEDETAILS_FIELDS    9     /* Count of fields in FILEDETAILS */

      /* format of the extended search criteria for this class */
      typedef struct _FILESYS_SEARCH_INFO {
         USHORT Exclude;
         USHORT MustHave;

         BOOL   fIncludeLMD;
         USHORT LMDyear;
         USHORT LMDmonth;
         USHORT LMDday;
          SHORT LMDcriteria;

         BOOL   fIncludeLMT;
         USHORT LMThours;
         USHORT LMTminutes;
         USHORT LMTseconds;
          SHORT LMTcriteria;

         BOOL   fIncludeFDS;
         ULONG  FDSsize;
         SHORT  FDScriteria;

         BOOL   fIncludeFEAS;
         ULONG  FEASsize;
         SHORT  FEAScriteria;

         BOOL   fMustHaveNeedEA;
         BOOL   fMustNotHaveNeedEA;
         } FILESYS_SEARCH_INFO;
         typedef FILESYS_SEARCH_INFO *PFILESYS_SEARCH_INFO;


      /* Alignment macro: ensure alignment on 4byte boundary */

      #define ALIGN4(p) (PVOID)( ( ((ULONG)p) + 3 ) & 0xFFFFFFFC )

      /* return values for wpConfirmRenameFileWithExt */
      #define KEEP_RENAMEFILESWITHEXT     1
      #define DISCARD_RENAMEFILESWITHEXT  2
      #define CANCEL_RENAMEFILESWITHEXT   3


#define WPFileSystem_MajorVersion 1
#define WPFileSystem_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define WPFileSystemNewClass wpfsc
#pragma linkage(wpfsc, system)
#define WPFileSystemClassData wpfsd
#define WPFileSystemCClassData wpfsx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define WPFileSystem_classObj WPFileSystemClassData.classObject
#define _WPFileSystem WPFileSystem_classObj

/*
 * New and Renew macros for WPFileSystem
 */
#define _WPFileSystemNew() (_somNew(WPFileSystemClassData.classObject))
#define WPFileSystemNew() \
	( WPFileSystemClassData.classObject \
		? _WPFileSystemNew() \
		: ( WPFileSystemNewClass(WPFileSystem_MajorVersion, WPFileSystem_MinorVersion), _WPFileSystemNew() ) )
#define WPFileSystemRenew(buf) \
	( _somRenew(WPFileSystemClassData.classObject, buf) )

/*
 * Override method: wpUnInitData
 */
#define WPFileSystem_wpUnInitData(somSelf) \
	WPObject_wpUnInitData(somSelf)

/*
 * Override method: wpQueryHandle
 */
#define WPFileSystem_wpQueryHandle(somSelf) \
	WPObject_wpQueryHandle(somSelf)

/*
 * Override method: wpSaveImmediate
 */
#define WPFileSystem_wpSaveImmediate(somSelf) \
	WPObject_wpSaveImmediate(somSelf)

/*
 * Override method: wpFilterPopupMenu
 */
#define WPFileSystem_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect) \
	WPObject_wpFilterPopupMenu(somSelf,ulFlags,hwndCnr,fMultiSelect)

/*
 * Override method: wpSetTitle
 */
#define WPFileSystem_wpSetTitle(somSelf,pszNewTitle) \
	WPObject_wpSetTitle(somSelf,pszNewTitle)

/*
 * Override method: wpViewObject
 */
#define WPFileSystem_wpViewObject(somSelf,hwndCnr,ulView,param) \
	WPObject_wpViewObject(somSelf,hwndCnr,ulView,param)

/*
 * Override method: wpSwitchTo
 */
#define WPFileSystem_wpSwitchTo(somSelf,View) \
	WPObject_wpSwitchTo(somSelf,View)

/*
 * Override method: wpAddSettingsPages
 */
#define WPFileSystem_wpAddSettingsPages(somSelf,hwndNotebook) \
	WPObject_wpAddSettingsPages(somSelf,hwndNotebook)

/*
 * Override method: wpCopyObject
 */
#define WPFileSystem_wpCopyObject(somSelf,Folder,fLock) \
	WPObject_wpCopyObject(somSelf,Folder,fLock)

/*
 * Override method: wpCreateFromTemplate
 */
#define WPFileSystem_wpCreateFromTemplate(somSelf,folder,fLock) \
	WPObject_wpCreateFromTemplate(somSelf,folder,fLock)

/*
 * Override method: wpMoveObject
 */
#define WPFileSystem_wpMoveObject(somSelf,Folder) \
	WPObject_wpMoveObject(somSelf,Folder)

/*
 * Override method: wpQueryIconData
 */
#define WPFileSystem_wpQueryIconData(somSelf,pIconInfo) \
	WPObject_wpQueryIconData(somSelf,pIconInfo)

/*
 * Override method: wpSetIconData
 */
#define WPFileSystem_wpSetIconData(somSelf,pIconInfo) \
	WPObject_wpSetIconData(somSelf,pIconInfo)

/*
 * Override method: wpQueryDetailsData
 */
#define WPFileSystem_wpQueryDetailsData(somSelf,ppDetailsData,pcp) \
	WPObject_wpQueryDetailsData(somSelf,ppDetailsData,pcp)

/*
 * Override method: wpModifyPopupMenu
 */
#define WPFileSystem_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition) \
	WPObject_wpModifyPopupMenu(somSelf,hwndMenu,hwndCnr,iPosition)

/*
 * Override method: wpSaveState
 */
#define WPFileSystem_wpSaveState(somSelf) \
	WPObject_wpSaveState(somSelf)

/*
 * Override method: wpRestoreState
 */
#define WPFileSystem_wpRestoreState(somSelf,ulReserved) \
	WPObject_wpRestoreState(somSelf,ulReserved)

/*
 * Override method: wpMenuItemSelected
 */
#define WPFileSystem_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId) \
	WPObject_wpMenuItemSelected(somSelf,hwndFrame,ulMenuId)

/*
 * Override method: wpOpen
 */
#define WPFileSystem_wpOpen(somSelf,hwndCnr,ulView,param) \
	WPObject_wpOpen(somSelf,hwndCnr,ulView,param)

/*
 * Override method: wpDraggedOverObject
 */
#define WPFileSystem_wpDraggedOverObject(somSelf,DraggedOverObject) \
	WPObject_wpDraggedOverObject(somSelf,DraggedOverObject)

/*
 * Override method: wpDroppedOnObject
 */
#define WPFileSystem_wpDroppedOnObject(somSelf,DroppedOnObject) \
	WPObject_wpDroppedOnObject(somSelf,DroppedOnObject)

/*
 * Override method: wpFormatDragItem
 */
#define WPFileSystem_wpFormatDragItem(somSelf,pdrgItem) \
	WPObject_wpFormatDragItem(somSelf,pdrgItem)

/*
 * Override method: wpQueryNameClashOptions
 */
#define WPFileSystem_wpQueryNameClashOptions(somSelf,menuID) \
	WPObject_wpQueryNameClashOptions(somSelf,menuID)

/*
 * Override method: wpAppendObject
 */
#define WPFileSystem_wpAppendObject(somSelf,targetObject,fMove) \
	WPObject_wpAppendObject(somSelf,targetObject,fMove)

/*
 * Override method: wpReplaceObject
 */
#define WPFileSystem_wpReplaceObject(somSelf,targetObject,fMove) \
	WPObject_wpReplaceObject(somSelf,targetObject,fMove)

/*
 * Override method: wpQueryStyle
 */
#define WPFileSystem_wpQueryStyle(somSelf) \
	WPObject_wpQueryStyle(somSelf)

/*
 * Override method: wpSetStyle
 */
#define WPFileSystem_wpSetStyle(somSelf,ulNewStyle) \
	WPObject_wpSetStyle(somSelf,ulNewStyle)

/*
 * Override method: wpDoesObjectMatch
 */
#define WPFileSystem_wpDoesObjectMatch(somSelf,pvoidExtendedCriteria) \
	WPObject_wpDoesObjectMatch(somSelf,pvoidExtendedCriteria)

/*
 * New Method: wpSetRealName
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpSetRealName(WPFileSystem *somSelf,
		PSZ pszName);
#pragma linkage(somTP_WPFileSystem_wpSetRealName, system)
typedef somTP_WPFileSystem_wpSetRealName *somTD_WPFileSystem_wpSetRealName;
#define somMD_WPFileSystem_wpSetRealName "----"
#define WPFileSystem_wpSetRealName(somSelf,pszName) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetRealName) \
	(somSelf,pszName))
#define _wpSetRealName WPFileSystem_wpSetRealName

/*
 * New Method: wpSetType
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpSetType(WPFileSystem *somSelf,
		PSZ pszTypes,
		PFEA2LIST pfeal);
#pragma linkage(somTP_WPFileSystem_wpSetType, system)
typedef somTP_WPFileSystem_wpSetType *somTD_WPFileSystem_wpSetType;
#define somMD_WPFileSystem_wpSetType "----"
#define WPFileSystem_wpSetType(somSelf,pszTypes,pfeal) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetType) \
	(somSelf,pszTypes,pfeal))
#define _wpSetType WPFileSystem_wpSetType

/*
 * New Method: wpQueryType
 */
typedef PSZ    SOMLINK somTP_WPFileSystem_wpQueryType(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpQueryType, system)
typedef somTP_WPFileSystem_wpQueryType *somTD_WPFileSystem_wpQueryType;
#define somMD_WPFileSystem_wpQueryType "----"
#define WPFileSystem_wpQueryType(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryType) \
	(somSelf))
#define _wpQueryType WPFileSystem_wpQueryType

/*
 * New Method: wpSetAttr
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpSetAttr(WPFileSystem *somSelf,
		ULONG attrFile);
#pragma linkage(somTP_WPFileSystem_wpSetAttr, system)
typedef somTP_WPFileSystem_wpSetAttr *somTD_WPFileSystem_wpSetAttr;
#define somMD_WPFileSystem_wpSetAttr "----"
#define WPFileSystem_wpSetAttr(somSelf,attrFile) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetAttr) \
	(somSelf,attrFile))
#define _wpSetAttr WPFileSystem_wpSetAttr

/*
 * New Method: wpQueryAttr
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryAttr(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpQueryAttr, system)
typedef somTP_WPFileSystem_wpQueryAttr *somTD_WPFileSystem_wpQueryAttr;
#define somMD_WPFileSystem_wpQueryAttr "----"
#define WPFileSystem_wpQueryAttr(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryAttr) \
	(somSelf))
#define _wpQueryAttr WPFileSystem_wpQueryAttr

/*
 * New Method: wpAddFile1Page
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpAddFile1Page(WPFileSystem *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_WPFileSystem_wpAddFile1Page, system)
typedef somTP_WPFileSystem_wpAddFile1Page *somTD_WPFileSystem_wpAddFile1Page;
#define somMD_WPFileSystem_wpAddFile1Page "----"
#define WPFileSystem_wpAddFile1Page(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, WPFileSystem, wpAddFile1Page) \
	(somSelf,hwndNotebook))
#define _wpAddFile1Page WPFileSystem_wpAddFile1Page

/*
 * New Method: wpAddFile2Page
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpAddFile2Page(WPFileSystem *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_WPFileSystem_wpAddFile2Page, system)
typedef somTP_WPFileSystem_wpAddFile2Page *somTD_WPFileSystem_wpAddFile2Page;
#define somMD_WPFileSystem_wpAddFile2Page "----"
#define WPFileSystem_wpAddFile2Page(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, WPFileSystem, wpAddFile2Page) \
	(somSelf,hwndNotebook))
#define _wpAddFile2Page WPFileSystem_wpAddFile2Page

/*
 * New Method: wpAddFile3Page
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpAddFile3Page(WPFileSystem *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_WPFileSystem_wpAddFile3Page, system)
typedef somTP_WPFileSystem_wpAddFile3Page *somTD_WPFileSystem_wpAddFile3Page;
#define somMD_WPFileSystem_wpAddFile3Page "----"
#define WPFileSystem_wpAddFile3Page(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, WPFileSystem, wpAddFile3Page) \
	(somSelf,hwndNotebook))
#define _wpAddFile3Page WPFileSystem_wpAddFile3Page

/*
 * New Method: wpAddFileMenuPage
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpAddFileMenuPage(WPFileSystem *somSelf,
		HWND hwndNotebook);
#pragma linkage(somTP_WPFileSystem_wpAddFileMenuPage, system)
typedef somTP_WPFileSystem_wpAddFileMenuPage *somTD_WPFileSystem_wpAddFileMenuPage;
#define somMD_WPFileSystem_wpAddFileMenuPage "----"
#define WPFileSystem_wpAddFileMenuPage(somSelf,hwndNotebook) \
    (SOM_Resolve(somSelf, WPFileSystem, wpAddFileMenuPage) \
	(somSelf,hwndNotebook))
#define _wpAddFileMenuPage WPFileSystem_wpAddFileMenuPage

/*
 * New Method: wpQueryCreation
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryCreation(WPFileSystem *somSelf,
		FDATE *fdate,
		FTIME *ftime);
#pragma linkage(somTP_WPFileSystem_wpQueryCreation, system)
typedef somTP_WPFileSystem_wpQueryCreation *somTD_WPFileSystem_wpQueryCreation;
#define somMD_WPFileSystem_wpQueryCreation "----"
#define WPFileSystem_wpQueryCreation(somSelf,fdate,ftime) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryCreation) \
	(somSelf,fdate,ftime))
#define _wpQueryCreation WPFileSystem_wpQueryCreation

/*
 * New Method: wpQueryLastAccess
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryLastAccess(WPFileSystem *somSelf,
		FDATE *fdate,
		FTIME *ftime);
#pragma linkage(somTP_WPFileSystem_wpQueryLastAccess, system)
typedef somTP_WPFileSystem_wpQueryLastAccess *somTD_WPFileSystem_wpQueryLastAccess;
#define somMD_WPFileSystem_wpQueryLastAccess "----"
#define WPFileSystem_wpQueryLastAccess(somSelf,fdate,ftime) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryLastAccess) \
	(somSelf,fdate,ftime))
#define _wpQueryLastAccess WPFileSystem_wpQueryLastAccess

/*
 * New Method: wpQueryLastWrite
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryLastWrite(WPFileSystem *somSelf,
		FDATE *fdate,
		FTIME *ftime);
#pragma linkage(somTP_WPFileSystem_wpQueryLastWrite, system)
typedef somTP_WPFileSystem_wpQueryLastWrite *somTD_WPFileSystem_wpQueryLastWrite;
#define somMD_WPFileSystem_wpQueryLastWrite "----"
#define WPFileSystem_wpQueryLastWrite(somSelf,fdate,ftime) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryLastWrite) \
	(somSelf,fdate,ftime))
#define _wpQueryLastWrite WPFileSystem_wpQueryLastWrite

/*
 * New Method: wpQueryFileSize
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryFileSize(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpQueryFileSize, system)
typedef somTP_WPFileSystem_wpQueryFileSize *somTD_WPFileSystem_wpQueryFileSize;
#define somMD_WPFileSystem_wpQueryFileSize "----"
#define WPFileSystem_wpQueryFileSize(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryFileSize) \
	(somSelf))
#define _wpQueryFileSize WPFileSystem_wpQueryFileSize

/*
 * New Method: wpQueryEASize
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryEASize(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpQueryEASize, system)
typedef somTP_WPFileSystem_wpQueryEASize *somTD_WPFileSystem_wpQueryEASize;
#define somMD_WPFileSystem_wpQueryEASize "----"
#define WPFileSystem_wpQueryEASize(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryEASize) \
	(somSelf))
#define _wpQueryEASize WPFileSystem_wpQueryEASize

/*
 * New Method: wpSetDateInfo
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpSetDateInfo(WPFileSystem *somSelf,
		FILEFINDBUF4 *pstFileFindBuf);
#pragma linkage(somTP_WPFileSystem_wpSetDateInfo, system)
typedef somTP_WPFileSystem_wpSetDateInfo *somTD_WPFileSystem_wpSetDateInfo;
#define somMD_WPFileSystem_wpSetDateInfo "----"
#define WPFileSystem_wpSetDateInfo(somSelf,pstFileFindBuf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetDateInfo) \
	(somSelf,pstFileFindBuf))
#define _wpSetDateInfo WPFileSystem_wpSetDateInfo

/*
 * New Method: wpSetFileSizeInfo
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpSetFileSizeInfo(WPFileSystem *somSelf,
		ULONG cbFileSize,
		ULONG cbEASize);
#pragma linkage(somTP_WPFileSystem_wpSetFileSizeInfo, system)
typedef somTP_WPFileSystem_wpSetFileSizeInfo *somTD_WPFileSystem_wpSetFileSizeInfo;
#define somMD_WPFileSystem_wpSetFileSizeInfo "----"
#define WPFileSystem_wpSetFileSizeInfo(somSelf,cbFileSize,cbEASize) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetFileSizeInfo) \
	(somSelf,cbFileSize,cbEASize))
#define _wpSetFileSizeInfo WPFileSystem_wpSetFileSizeInfo

/*
 * New Method: wpRefresh
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpRefresh(WPFileSystem *somSelf,
		ULONG ulView,
		PVOID pReserved);
#pragma linkage(somTP_WPFileSystem_wpRefresh, system)
typedef somTP_WPFileSystem_wpRefresh *somTD_WPFileSystem_wpRefresh;
#define somMD_WPFileSystem_wpRefresh "----"
#define WPFileSystem_wpRefresh(somSelf,ulView,pReserved) \
    (SOM_Resolve(somSelf, WPFileSystem, wpRefresh) \
	(somSelf,ulView,pReserved))
#define _wpRefresh WPFileSystem_wpRefresh

/*
 * New Method: wpQueryRefreshFlags
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpQueryRefreshFlags(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpQueryRefreshFlags, system)
typedef somTP_WPFileSystem_wpQueryRefreshFlags *somTD_WPFileSystem_wpQueryRefreshFlags;
#define somMD_WPFileSystem_wpQueryRefreshFlags "----"
#define WPFileSystem_wpQueryRefreshFlags(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryRefreshFlags) \
	(somSelf))
#define _wpQueryRefreshFlags WPFileSystem_wpQueryRefreshFlags

/*
 * New Method: wpSetRefreshFlags
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpSetRefreshFlags(WPFileSystem *somSelf,
		ULONG ulRefreshFlags);
#pragma linkage(somTP_WPFileSystem_wpSetRefreshFlags, system)
typedef somTP_WPFileSystem_wpSetRefreshFlags *somTD_WPFileSystem_wpSetRefreshFlags;
#define somMD_WPFileSystem_wpSetRefreshFlags "----"
#define WPFileSystem_wpSetRefreshFlags(somSelf,ulRefreshFlags) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetRefreshFlags) \
	(somSelf,ulRefreshFlags))
#define _wpSetRefreshFlags WPFileSystem_wpSetRefreshFlags

/*
 * New Method: wpPrintPlainTextFile
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpPrintPlainTextFile(WPFileSystem *somSelf,
		PPRINTDEST pPrintDest);
#pragma linkage(somTP_WPFileSystem_wpPrintPlainTextFile, system)
typedef somTP_WPFileSystem_wpPrintPlainTextFile *somTD_WPFileSystem_wpPrintPlainTextFile;
#define somMD_WPFileSystem_wpPrintPlainTextFile "----"
#define WPFileSystem_wpPrintPlainTextFile(somSelf,pPrintDest) \
    (SOM_Resolve(somSelf, WPFileSystem, wpPrintPlainTextFile) \
	(somSelf,pPrintDest))
#define _wpPrintPlainTextFile WPFileSystem_wpPrintPlainTextFile

/*
 * New Method: wpSetTitleAndRenameFile
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpSetTitleAndRenameFile(WPFileSystem *somSelf,
		PSZ pszNewTitle,
		ULONG fConfirmations);
#pragma linkage(somTP_WPFileSystem_wpSetTitleAndRenameFile, system)
typedef somTP_WPFileSystem_wpSetTitleAndRenameFile *somTD_WPFileSystem_wpSetTitleAndRenameFile;
#define somMD_WPFileSystem_wpSetTitleAndRenameFile "----"
#define WPFileSystem_wpSetTitleAndRenameFile(somSelf,pszNewTitle,fConfirmations) \
    (SOM_Resolve(somSelf, WPFileSystem, wpSetTitleAndRenameFile) \
	(somSelf,pszNewTitle,fConfirmations))
#define _wpSetTitleAndRenameFile WPFileSystem_wpSetTitleAndRenameFile

/*
 * New Method: wpConfirmRenameFileWithExt
 */
typedef ULONG    SOMLINK somTP_WPFileSystem_wpConfirmRenameFileWithExt(WPFileSystem *somSelf);
#pragma linkage(somTP_WPFileSystem_wpConfirmRenameFileWithExt, system)
typedef somTP_WPFileSystem_wpConfirmRenameFileWithExt *somTD_WPFileSystem_wpConfirmRenameFileWithExt;
#define somMD_WPFileSystem_wpConfirmRenameFileWithExt "----"
#define WPFileSystem_wpConfirmRenameFileWithExt(somSelf) \
    (SOM_Resolve(somSelf, WPFileSystem, wpConfirmRenameFileWithExt) \
	(somSelf))
#define _wpConfirmRenameFileWithExt WPFileSystem_wpConfirmRenameFileWithExt

/*
 * New Method: wpQueryRealName
 */
typedef BOOL    SOMLINK somTP_WPFileSystem_wpQueryRealName(WPFileSystem *somSelf,
		PSZ pszFilename,
		PULONG pcb,
		BOOL fQualified);
#pragma linkage(somTP_WPFileSystem_wpQueryRealName, system)
typedef somTP_WPFileSystem_wpQueryRealName *somTD_WPFileSystem_wpQueryRealName;
#define somMD_WPFileSystem_wpQueryRealName "----"
#define WPFileSystem_wpQueryRealName(somSelf,pszFilename,pcb,fQualified) \
    (SOM_Resolve(somSelf, WPFileSystem, wpQueryRealName) \
	(somSelf,pszFilename,pcb,fQualified))
#define _wpQueryRealName WPFileSystem_wpQueryRealName

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK WPFileSystemNewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(WPFileSystemNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct WPFileSystemClassDataStructure {
	SOMAny *classObject;
	somMToken wpSetRealName;
	somMToken withdrawn_wpQueryRealName;
	somMToken wpSetType;
	somMToken wpQueryType;
	somMToken wpSetAttr;
	somMToken wpQueryAttr;
	somMToken wpQueryFilename;
	somMToken wpAddFile1Page;
	somMToken wpAddFile2Page;
	somMToken wpAddFile3Page;
	somMToken wpAddFileMenuPage;
	somMToken wpQueryCreation;
	somMToken wpQueryLastAccess;
	somMToken wpQueryLastWrite;
	somMToken wpQueryFileSize;
	somMToken wpQueryEASize;
	somMToken wpSetDateInfo;
	somMToken wpSetFileSizeInfo;
	somMToken wpRefresh;
	somMToken wpPrintPlainTextFile;
	somMToken wpSetRefreshFlags;
	somMToken wpQueryRefreshFlags;
	somMToken wpQueryDriveData;
	somMToken wpSetTitleAndRenameFile;
	somMToken wpConfirmRenameFileWithExt;
	somMToken wpConfirmKeepAssoc;
	somMToken wpAddUserMenuItem;
	somMToken wpQueryDisk;
	somMToken wpQueryDateInfo;
	somMToken wpSetNewRealName;
	somMToken wpAdoptNewRealName;
	somMToken wpQueryRealName;
} WPFileSystemClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct WPFileSystemCClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} WPFileSystemCClassData;

#endif       /* wpfsys_h */

/*
 * This file was generated by the SOM Compiler.
 * FileName: ..\..\ibmh\wpfsys.h.
 * Generated using:
 *     SOM Precompiler spc: 1.22
 *     SOM Emitter emith: 1.11
 */

#ifndef wpfsys_mh
#define wpfsys_mh


/*
 * Define the class name as an object type
 */
#ifndef M_WPFileSystem
#define M_WPFileSystem SOMAny
#endif

#define M_WPFileSystem_MajorVersion 1
#define M_WPFileSystem_MinorVersion 2

/*
 * External name shortening if required
 */
#ifdef SOM_USE_SHORT_EXTERNAL_NAMES
#define M_WPFileSystemNewClass wpfsc
#pragma linkage(wpfsc, system)
#define M_WPFileSystemClassData wpfsd
#define M_WPFileSystemCClassData wpfsx
#endif /* SOM_USE_SHORT_EXTERNAL_NAMES */
/*--------------Migration------------*/
#define M_WPFileSystem_classObj M_WPFileSystemClassData.classObject
#define _M_WPFileSystem M_WPFileSystem_classObj

/*
 * New and Renew macros for M_WPFileSystem
 */
#define _M_WPFileSystemNew() (_somNew(M_WPFileSystemClassData.classObject))
#define M_WPFileSystemNew() \
	( M_WPFileSystemClassData.classObject \
		? _M_WPFileSystemNew() \
		: ( M_WPFileSystemNewClass(M_WPFileSystem_MajorVersion, M_WPFileSystem_MinorVersion), _M_WPFileSystemNew() ) )
#define M_WPFileSystemRenew(buf) \
	( _somRenew(M_WPFileSystemClassData.classObject, buf) )

/*
 * Override method: wpclsInitData
 */
#define M_WPFileSystem_wpclsInitData(somSelf) \
	M_WPObject_wpclsInitData(somSelf)

/*
 * Override method: wpclsQueryTitle
 */
#define M_WPFileSystem_wpclsQueryTitle(somSelf) \
	M_WPObject_wpclsQueryTitle(somSelf)

/*
 * Override method: wpclsQueryDetailsInfo
 */
#define M_WPFileSystem_wpclsQueryDetailsInfo(somSelf,ppClassFieldInfo,pSize) \
	M_WPObject_wpclsQueryDetailsInfo(somSelf,ppClassFieldInfo,pSize)

/*
 * Override method: wpclsQuerySearchInfo
 */
#define M_WPFileSystem_wpclsQuerySearchInfo(somSelf,ClassExtended,ClassCreate,pulClassCriteriaSize) \
	M_WPObject_wpclsQuerySearchInfo(somSelf,ClassExtended,ClassCreate,pulClassCriteriaSize)

/*
 * Override method: wpclsQueryExtendedCriteria
 */
#define M_WPFileSystem_wpclsQueryExtendedCriteria(somSelf,pszName,ulSearchType,pvoidExtendedCriteria) \
	M_WPObject_wpclsQueryExtendedCriteria(somSelf,pszName,ulSearchType,pvoidExtendedCriteria)

/*
 * New Method: wpclsQueryObjectFromPath
 */
typedef WPObject *   SOMLINK somTP_M_WPFileSystem_wpclsQueryObjectFromPath(M_WPFileSystem *somSelf,
		PSZ pszFQPath);
#pragma linkage(somTP_M_WPFileSystem_wpclsQueryObjectFromPath, system)
typedef somTP_M_WPFileSystem_wpclsQueryObjectFromPath *somTD_M_WPFileSystem_wpclsQueryObjectFromPath;
#define somMD_M_WPFileSystem_wpclsQueryObjectFromPath "----"
#define M_WPFileSystem_wpclsQueryObjectFromPath(somSelf,pszFQPath) \
    (SOM_Resolve(somSelf, M_WPFileSystem, wpclsQueryObjectFromPath) \
	(somSelf,pszFQPath))
#define _wpclsQueryObjectFromPath M_WPFileSystem_wpclsQueryObjectFromPath

/*
 * New Method: wpclsQueryInstanceType
 */
typedef PSZ    SOMLINK somTP_M_WPFileSystem_wpclsQueryInstanceType(M_WPFileSystem *somSelf);
#pragma linkage(somTP_M_WPFileSystem_wpclsQueryInstanceType, system)
typedef somTP_M_WPFileSystem_wpclsQueryInstanceType *somTD_M_WPFileSystem_wpclsQueryInstanceType;
#define somMD_M_WPFileSystem_wpclsQueryInstanceType "----"
#define M_WPFileSystem_wpclsQueryInstanceType(somSelf) \
    (SOM_Resolve(somSelf, M_WPFileSystem, wpclsQueryInstanceType) \
	(somSelf))
#define _wpclsQueryInstanceType M_WPFileSystem_wpclsQueryInstanceType

/*
 * New Method: wpclsQueryInstanceFilter
 */
typedef PSZ    SOMLINK somTP_M_WPFileSystem_wpclsQueryInstanceFilter(M_WPFileSystem *somSelf);
#pragma linkage(somTP_M_WPFileSystem_wpclsQueryInstanceFilter, system)
typedef somTP_M_WPFileSystem_wpclsQueryInstanceFilter *somTD_M_WPFileSystem_wpclsQueryInstanceFilter;
#define somMD_M_WPFileSystem_wpclsQueryInstanceFilter "----"
#define M_WPFileSystem_wpclsQueryInstanceFilter(somSelf) \
    (SOM_Resolve(somSelf, M_WPFileSystem, wpclsQueryInstanceFilter) \
	(somSelf))
#define _wpclsQueryInstanceFilter M_WPFileSystem_wpclsQueryInstanceFilter

/*
 * Declare the class creation procedure
 */
SOMEXTERN SOMAny * SOMLINK M_WPFileSystemNewClass(integer4 scemajorVersion,
		integer4 sceminorVersion);
#pragma linkage(M_WPFileSystemNewClass, system)

/*
 * Declare the class data structure
 */
SOMEXTERN struct M_WPFileSystemClassDataStructure {
	SOMAny *classObject;
	somMToken wpclsQueryInstanceType;
	somMToken wpclsQueryInstanceFilter;
	somMToken wpclsQueryObjectFromPath;
} M_WPFileSystemClassData;

/*
 * Declare the C specific class data structure
 */
SOMEXTERN struct M_WPFileSystemCClassDataStructure {
	somMethodTab *parentMtab;
	somDToken instanceDataToken;
} M_WPFileSystemCClassData;

#endif       /* wpfsys_h */
