/*****************************************************************************/
/*                                                                           */
/* This file is part of a program which creates and manages a Microsoft .LIB */
/* format file containing Microsoft standard object modules. This version is */
/* specifically for use with IBM OS/2 2.0.                                   */
/*                                                                           */
/* Copyright (C) 1992 Jonathan Sykes (jsykes@aol.com)                        */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* General Public License for more details.                                  */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   File Name :  ReadLibHeader.c                                            */
/*                                                                           */
/*   Called By :  Lib.c                                                      */
/*                                                                           */
/*   Calls     :  GetByte.c, GetRecLen.c, GetWord.c                          */
/*                                                                           */
/*   Date      :  29-Aug-92                                                  */
/*                                                                           */
/*****************************************************************************/
void  ReadLibHeader (fp)
FILE  *fp;
  {
  Word LoWord, HiWord;

  fseek (fp, 0L, SEEK_SET);

  if ((LHRec.RecType = GetByte (fp)) != LIBHDR)
    {
    printf ("Invalid library header record\n");
    exit (-1);
    }
  
  LHRec.RecLen    = GetRecLen (fp);
  LoWord          = GetWord (fp, SWAP);
  HiWord          = GetWord (fp, SWAP);
  LHRec.DirOffset = (long)((HiWord << 16) + LoWord);
  LHRec.DirPages  = GetWord (fp, SWAP);

  if (Debug)
    {
    printf ("Library Rec Len = %xh\n", LHRec.RecLen);
    printf ("Library Dir Off = %xh\n", LHRec.DirOffset);
    printf ("Library Dir Pag = %xh\n", LHRec.DirPages);
    }
  }
