/*****************************************************************************/
/*                                                                           */
/* This file is part of a program which creates and manages a Microsoft .LIB */
/* format file containing Microsoft standard object modules. This version is */
/* specifically for use with IBM OS/2 2.0.                                   */
/*                                                                           */
/* Copyright (C) 1992 Jonathan Sykes (jsykes@aol.com)                        */
/*                                                                           */
/* This program is free software; you can redistribute it and/or modify it   */
/* under the terms of the GNU General Public License as published by the     */
/* Free Software Foundation; either version 2 of the License, or (at your    */
/* option) any later version.                                                */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         */
/* General Public License for more details.                                  */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with this program; if not, write to the Free Software               */
/* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   File Name :  RewriteObj.c                                               */
/*                                                                           */
/*   Called By :  Lib.c                                                      */
/*                                                                           */
/*   Calls     :  DoTheadr.c, EatRec.c, GetByte.c, Pad.c                     */
/*                                                                           */
/*   Date      :  29-Aug-92                                                  */
/*                                                                           */
/*****************************************************************************/
unsigned long RewriteObj (fp, block)
FILE  *fp;
Word   block;
  {
  Byte    b;
  unsigned
    long  offset, liboffset;

  offset = (block * 16);

  ChkSumFlg = TRUE;
  ChkSum    = 0;

  fseek (fp, offset, SEEK_SET);
  liboffset = Pad (LIBFNew, PAGESIZE);

  ObjWrite = TRUE; /* Calls to GetByte will write to ObjF aswell */

  if (GetByte (fp) != THEADR)
    {
    printf ("Invalid object module header\n");
    exit (ERROR);
    }

  CurRec = THEADR;  
  DoTheadr (fp);

  if (Debug)
    printf ("Library Object Offset = %04xh for module %s\n", liboffset, CurObj);

  b = GetByte (fp);
  CurRec = b;
  while ((b != MODEND) && (b != MODEND2) && (b != 0))
    {
    EatRec (fp);
    b = GetByte (fp);
    CurRec = b;
    }

  if (b != 0)
    EatRec (fp);

  ObjWrite = FALSE;
  return (liboffset);
  }
