#include <stdio.h>
#include <sys/types.h>
#include <dirent.h>
#include <fcntl.h>
#include <sys/stat.h>

void process (char *infile, char *outfile, char *t1, char *t1acc,
              char *t2, char *t2acc, char *prefix);

void usage ()
{
   fprintf (stderr, "genclass type1 {ref|val} proto [out_prefix]\n");
   fprintf (stderr, "genclass -2 type1 {ref|val} type2 {ref|val} proto [out_prefix]\n");
   exit(1);
}


main(int argc, char *argv[])
{
   char *protodir;
   char currentdir[512];
   int twotypes;
   char *t1, *t1acc, *t2, *t2acc;
   char protoh[512];
   char protocc[512];
   char prefix[512];
   char protohpath[512];
   char protoccpath[512];
   DIR *searchdir;
   struct dirent *searchfile;
   char outh[512];
   char outcc[512];

   if (argc == 1 || (strcmp (argv[1], "-usage") == 0)) {
      usage();
      exit (0);
   }

   if (strcmp (argv[1], "-version") == 0) {
      fprintf (stdout, "genclass: version 1.0.c\n");
      exit (0);
   }

   protodir = (char *)getenv ("PROTODIR");
   getcwd (&currentdir[1], 511);
   currentdir[0] = '\\';

   if (strcmp (argv[1], "-2") == 0) {
      if (argc != 7 && argc != 8)
         usage();
      twotypes = 1;
      t1 = argv[2];
      if (strcmp (argv[3], "ref") == 0)
         t1acc = "&";
      else
         if (strcmp (argv[3], "val") == 0)
            t1acc = " ";
         else
            usage();
      t2 = argv[4];
      if (strcmp (argv[5], "ref") == 0)
         t2acc = "&";
      else
         if (strcmp (argv[5], "val") == 0)
            t2acc = " ";
         else
            usage();
      strcat (strcpy (protoh, argv[6]), ".hP");
      strcat (strcpy (protocc, argv[6]), ".ccP");
      if (argc == 8)
         strcpy (prefix, argv[7]);
      else {
         strcpy (prefix, argv[2]);
         strcat (prefix, argv[4]);
      }
   } else {
      if (argc != 4 && argc != 5)
         usage();
      twotypes = 0;
      t1 = argv[1];
      if (strcmp (argv[2], "ref") == 0)
         t1acc = "&";
      else
         if (strcmp (argv[2], "val") == 0)
            t1acc = " ";
         else
            usage();
      t2 = "";
      t2acc = "";
      strcat (strcpy (protoh, argv[3]), ".hP");
      strcat (strcpy (protocc, argv[3]), ".ccP");
      if (argc == 5)
         strcpy (prefix, argv[4]);
      else
         strcpy (prefix, argv[1]);
   }

   protohpath[0] = 0;
   protoccpath[0] = 0;

   /* find the proto files */
   if (protodir && (searchdir = opendir (protodir))) {
      readdir (searchdir);
      readdir (searchdir);
      while (searchfile = readdir (searchdir)) {
         if (strcmp (protoh, searchfile -> d_name) == 0)
            strcpy (protohpath, protodir);
         else
            if (strcmp (protocc, searchfile -> d_name) == 0)
               strcpy (protoccpath, protodir);
      }
      closedir (searchdir);
   }

   if (protohpath[0] == 0) {
      searchdir = opendir (currentdir);
      readdir (searchdir);
      readdir (searchdir);
      while ((searchfile = readdir (searchdir))) {
         if (strcmp (protoh, searchfile -> d_name) == 0)
            strcpy (protohpath, ".\\");
         else
            if (strcmp (protocc, searchfile -> d_name) == 0)
               strcpy (protoccpath, ".\\");
      }
      closedir (searchdir);
   }

   if (protohpath[0] == 0)
      usage();

   strcat (strcat (protohpath, "\\"), protoh);
   strcat (strcpy (outh, prefix), protoh);
   outh[strlen (outh) - 1] = '\0';
   process (protohpath, outh, t1, t1acc, t2, t2acc, prefix);

   if (protoccpath[0]) {
      strcat (strcat (protoccpath, "\\"), protocc);
      strcat (strcpy (outcc, prefix), protocc);
      outcc[strlen (outcc) - 1] = '\0';
      process (protoccpath, outcc, t1, t1acc, t2, t2acc, prefix);
   }

   exit (0);
}


void process (char *infile,
              char *outfile,
              char *t1,
              char *t1acc,
              char *t2, 
              char *t2acc,
              char *prefix)
{
   struct stat statbuf;
   char *inbuf, *outbuf;
   char *ip, *op;
   int ifd, ofd;

   stat (infile, &statbuf);

   ifd = open (infile, O_BINARY);

   inbuf = (char *) malloc (statbuf.st_size + 1);
   outbuf = (char *) malloc (statbuf.st_size * 2);

   read (ifd, inbuf, statbuf.st_size);

   inbuf[statbuf.st_size + 1] = '\0';

   ip = inbuf;
   op = outbuf;

   while (*ip) {
	if (*ip == '<') {
		if (ip[1] == 'T') {
			if (ip[2] == '>') {
				if (ip[3] == '.') {
					strcpy (op, prefix);
					op += strlen (prefix);
					ip += 4;
					if (!strncmp (ip, "<C>.", 4))
						ip += 4;
				} else {
					strcpy (op, t1);
					op += strlen (t1);
					ip += 3;
				}
			} else {
				if (ip[2] == '&') {
					if (ip[3] == '>') {
						strcpy (op, t1);
						op += strlen (t1);
						strcpy (op, t1acc);
						op += strlen (t1acc);
						ip += 4;
					} else {
						*op++ = *ip++;
					}
				} else {
					*op++ = *ip++;
				}
				
			}
		} else {
			if (ip[1] == 'C') {
				if (ip[2] == '>') {
					if (ip[3] == '.') {
						strcpy (op, prefix);
						op += strlen (prefix);
						ip += 4;
						if (!strncmp (ip, "<T>.", 4))
							ip += 4;
					} else {
						strcpy (op, t2);
						op += strlen (t2);
						ip += 3;
					}
				} else {
					if (ip[2] == '&') {
						if (ip[3] == '>') {
							strcpy (op, t2);
							op += strlen (t2);
							strcpy (op, t2acc);
							op += strlen (t2acc);
							ip += 4;
						} else {
							*op++ = *ip++;
						}
					} else {
						*op++ = *ip++;
					}
					
				}
			} else {
				*op++ = *ip++;
			}
		}
	} else {
		*op++ = *ip++;
	}
   }

   ofd = open (outfile, O_CREAT | O_TRUNC | O_BINARY, 0666);
   write (ofd, outbuf, op - outbuf);
   close (ofd);
   close (ifd);
}

